<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: consist.php,v 1.23 2002/02/12 20:26:44 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

	set_time_limit(600);

	include_once "GLOBALS.php";
	
	$GLOBALS['ADMIN_FORM'] = 1;
	$GLOBALS['USER_REG'] = 1;
	$GLOBALS['MSG_EDIT'] = 1;
	
	fud_use('db.inc');
	fud_use('glob.inc');
	fud_use('msg.inc');
	fud_use('util.inc');
	fud_use('widgets.inc');
	fud_use('thread.inc');
	fud_use('users.inc');
	fud_use('adm.inc');
	fud_use('level_adm.inc');
	fud_use('customtags.inc');
	fud_use('ext.inc');
	
	list($ses, $usr) = initadm();
function draw_stat($text)
{
	echo '<b>'.htmlspecialchars($text).'</b><br>';
	flush();
}

function draw_info($cnt)
{
	if ( $cnt < 1 ) 
		draw_stat('OK');
	else
		draw_stat($cnt.' entries unmatched, deleted');
}

	include('admpanel.php');

	if( $GLOBALS['FORUM_ENABLED'] == 'Y' ) {
		draw_stat('Disabling the forum for the duration of maintenance run');
		maintenance_status('Undergoing maintenance, please come back later.', 'N');
	}
	
	draw_stat('Locking the database for checking');
	/* normal forum messages */
	DB_LOCK('
		fud_thread+, 
		fud_thread_view+,
		fud_forum+, 
		fud_cat+, 
		fud_msg+, 
		fud_mod+, 
		fud_users+, 
		fud_users AS fud_users_2+, 
		fud_read+, 
		fud_poll+, 
		fud_poll_opt+, 
		fud_poll_opt_track+, 
		fud_smiley+, 
		fud_thread_notify+, 
		fud_forum_notify+, 
		fud_attach+, 
		fud_msg_report+, 
		fud_thread_rate_track+, 
		fud_level+, 
		fud_custom_tags+,
		fud_user_ignore,
		fud_buddy+,
		fud_pmsg+,
		fud_ext_block+
	');
	draw_stat('Locked!');

	draw_stat('Validating category order');
	$i=1;
	$r = Q("SELECT id,view_order FROM fud_cat ORDER BY view_order,id");
	while( list($id,$view_order) = DB_ROWARR($r) ) {
		if( $view_order != $i ) Q("UPDATE fud_cat SET view_order=".$i." WHERE id=".$id);
		$i++;
	}
	QF($r);
	draw_stat('Done: Validating category order');

	draw_stat('Checking if moderator and users table match');
	$cnt = 0;
	/* forum moderators exist, mod->users */
	$result = Q("SELECT fud_mod.id AS tbl_mod_id, fud_users.id AS tbl_user_id, fud_forum.id AS tbl_forum_id FROM fud_mod LEFT JOIN fud_users ON fud_mod.user_id=fud_users.id LEFT JOIN fud_forum ON fud_mod.forum_id=fud_forum.id");
	while ( $obj = DB_ROWOBJ($result) ) {
		if ( !strlen($obj->tbl_user_id) || !strlen($obj->tbl_forum_id) ) {
			Q("DELETE FROM fud_mod WHERE id=".$obj->tbl_mod_id);
			++$cnt;
		} 
	}
	QF($result);
	draw_info($cnt);
	
	draw_stat('Rebuilding moderators');
	$ar = array();
	$r = Q("SELECT fud_users.id,fud_users.login,fud_mod.forum_id FROM fud_mod LEFT JOIN fud_users ON fud_mod.user_id=fud_users.id ORDER BY forum_id");
	while ( $obj = DB_ROWOBJ($r) ) {
		if( empty($ar[$obj->forum_id]) ) $ar[$obj->forum_id]=NULL;
		$ar[$obj->forum_id] .= addslashes('<a href="usrinfo.php?id='.$obj->id.'&\'.$_RSID.\'" class="GenLink">'.htmlspecialchars(trim_show_len($obj->login,'LOGIN')).'</a> ');
	}
	QF($r);
	
	reset($ar);
	while( list($k,$v) = each($ar) ) {
		if( $k ) Q("UPDATE fud_forum SET moderators='echo \'".$v."\';' WHERE id=".$k);	
	}
	
	Q("UPDATE fud_users SET is_mod='N' WHERE is_mod!='A'");
	$r = Q("SELECT user_id FROM fud_mod INNER JOIN fud_users ON fud_users.id=fud_mod.user_id WHERE fud_users.is_mod!='A' GROUP BY user_id");
	while( list($uid) = DB_ROWARR($r) ) Q("UPDATE fud_users SET is_mod='Y' WHERE id=".$uid);
	QF($r);
	
	draw_stat('Done: Rebuilding moderators');
		
	draw_stat('Checking if all private messages have users');
	$cnt = 0;

	$r = Q("SELECT fud_pmsg.id FROM fud_pmsg LEFT JOIN fud_users ON fud_pmsg.ouser_id=fud_users.id WHERE mailed='N' AND fud_users.id IS NULL");
	while( $obj = DB_ROWOBJ($r) ) {
		$pmsg = new fud_pmsg;
		$pmsg->get($obj->id);
		$pmsg->del_pmsg('TRASH');
		++$cnt;
	}

	$r = Q("SELECT fud_pmsg.id FROM fud_pmsg LEFT JOIN fud_users ON fud_pmsg.duser_id=fud_users.id WHERE mailed='Y' AND fud_users.id IS NULL");
	while( $obj = DB_ROWOBJ($r) ) {
		$pmsg = new fud_pmsg;
		$pmsg->get($obj->id);
		$pmsg->del_pmsg('TRASH');
		++$cnt;
	}
	
	draw_info($cnt);
	
	draw_stat('Checking read table against users');
	$cnt = 0;
	/* read messages->users */
	$result=Q("SELECT fud_read.id, fud_users.id AS usr_id FROM fud_read LEFT JOIN fud_users ON fud_read.user_id=fud_users.id");
	while ( $obj = DB_ROWOBJ($result) ) {
		if ( empty($obj->usr_id) ) {
			++$cnt;
			Q("DELETE FROM fud_read WHERE id=".$obj->id);
		}
	}
	QF($result);
	draw_info($cnt);
	
	draw_stat('Checking read table against threads/messages');
	$cnt=0;
 	/* read thread->thread/user */ 
	$result=Q("SELECT fud_read.id, fud_thread.id AS thread_id FROM fud_read LEFT JOIN fud_thread ON fud_read.thread_id=fud_thread.id LEFT JOIN fud_msg ON fud_thread.root_msg_id=fud_msg.id LEFT JOIN fud_users ON fud_msg.poster_id=fud_users.id");
	while ( $obj = DB_ROWOBJ($result) ) {
		if ( empty($obj->thread_id) ) {
			++$cnt;
			Q("DELETE FROM fud_read WHERE id=".$obj->id);
		}
	}
	QF($result);
	draw_info($cnt);
	
	draw_stat('Checking file attachments against messages');
	$result = Q("SELECT fud_attach.id,fud_attach.location FROM fud_attach LEFT JOIN fud_msg ON fud_attach.message_id=fud_msg.id WHERE fud_msg.id IS NULL");
	if( ($cnt = DB_COUNT($result)) ) {
		while ( $obj = DB_ROWOBJ($result) ) {
			if( file_exists($obj->location) ) unlink($obj->location);
			Q("DELETE FROM fud_attach WHERE id=".$obj->id);	
		}
	}
	if( $cnt ) draw_stat("$cnt Bad Attachments removed");
	draw_stat('Done: Checking file attachments against messages');
	
	draw_stat('Checking attachment counts in messages');
	$result = Q("SELECT fud_msg.id,count(*) AS attach_count,fud_msg.attach_cnt FROM fud_attach LEFT JOIN fud_msg ON fud_attach.message_id=fud_msg.id WHERE fud_msg.id IS NOT NULL GROUP BY fud_msg.id");
	if( DB_COUNT($result) ) {
		while( $obj = DB_ROWOBJ($result) ) {
			if( $obj->attach_count != $obj->attach_cnt ) 
				Q("UPDATE fud_msg SET attach_cnt=".$obj->attach_count." WHERE id=".$obj->id);
		}
	}
	$result = Q("SELECT fud_msg.id FROM fud_msg LEFT JOIN fud_attach ON fud_attach.message_id=fud_msg.id WHERE fud_msg.attach_cnt>0 AND fud_attach.id IS NULL GROUP BY fud_msg.id");
	if( DB_COUNT($result) ) {
		while( $obj = DB_ROWOBJ($result) ) {
			Q("UPDATE fud_msg SET attach_cnt=0 WHERE id=".$obj->id);
		}
	}
	draw_stat('Done: Checking attachment counts in messages');
	
	draw_stat('Checking polls against messages');
	$cnt = 0;
	$result=Q("SELECT fud_poll.id, fud_msg.id AS msg_id FROM fud_poll LEFT JOIN fud_msg ON fud_poll.id=fud_msg.poll_id WHERE fud_msg.id IS NULL");
	while ( $obj = DB_ROWOBJ($result) ) {
		$cnt++;
		Q("DELETE FROM fud_poll WHERE id=".$obj->id);
	}
	QF($result);
	draw_info($cnt);
	
	draw_stat('Checking message reports');
	$cnt = 0;
	$result = Q("SELECT fud_msg_report.id FROM fud_msg_report LEFT JOIN fud_msg ON fud_msg_report.msg_id=fud_msg.id WHERE fud_msg.id IS NULL");
	while ( $obj = DB_ROWOBJ($result) ) {
		$cnt++;
		Q("DELETE FROM fud_msg_report WHERE id=".$obj->id);	
	}
	QF($result);
	draw_info($cnt);
	
	draw_stat('Checking poll tracking against poll options, users');
	$cnt = 0;
	/* users -> polls tracking */
	$result=Q("SELECT fud_poll_opt_track.id AS opt_id, fud_users.id AS usr_id FROM fud_poll_opt_track LEFT JOIN fud_poll ON fud_poll_opt_track.poll_id=fud_poll.id LEFT JOIN fud_users ON fud_poll_opt_track.user_id=fud_users.id");
	while ( $obj = DB_ROWOBJ($result) ) {
		if ( empty($obj->usr_id) ) {
			++$cnt;
			Q("DELETE FROM fud_poll_opt_track WHERE id=".$obj->opt_id);
		}
	}
	QF($result);
	draw_info($cnt);
	
	draw_stat('Checking if all poll options belong to exisiting polls');
	$cnt = 0;
	/* poll options -> polls */
	$result=Q("SELECT fud_poll_opt.id, fud_poll.id AS poll_id FROM fud_poll_opt LEFT JOIN fud_poll ON fud_poll_opt.poll_id=fud_poll.id");
	while ( $obj = DB_ROWOBJ($result) ) {
		if ( empty($obj->poll_id) ) {
			++$cnt;
			Q("DELETE FROM fud_poll_opt WHERE id=".$obj->id);
		}
	}
	QF($result);
	draw_info($cnt);
	
	draw_stat('Checking all poll tracking against polls');
	$cnt = 0;
	/* poll votes -> polls */
	$result=Q("SELECT fud_poll_opt_track.id AS t_id, fud_poll.id AS poll_id FROM fud_poll_opt_track LEFT JOIN fud_poll ON fud_poll_opt_track.poll_id=fud_poll.id");
	while ( $obj = DB_ROWOBJ($result) ) {
		if ( empty($obj->poll_id) ) {
			++$cnt;
			Q("DELETE FROM fud_poll_opt_track WHERE id=".$obj->t_id);
		}
	}
	QF($result);
	draw_info($cnt);
	
	draw_stat('Checking threads forum relations');
	$cnt = 0;
	/* threads -> forum */
	$r = Q("SELECT fud_thread.id AS thread_id, fud_forum.id FROM fud_thread LEFT JOIN fud_forum ON fud_thread.forum_id=fud_forum.id");
	while ( $obj = DB_ROWOBJ($r) ) {
		if ( strlen($obj->id) ) continue;
		++$cnt;
		$thr = new fud_thread;
		$thr->get($obj->thread_id);
		$thr->delete();
		unset($thr);
	}
	QF($r);
	draw_info($cnt);
	
	draw_stat('Checking message thread relations');
	$cnt = 0;
	$r = Q("SELECT fud_msg.id AS msg_id, fud_thread.id FROM fud_msg LEFT JOIN fud_thread ON fud_msg.thread_id=fud_thread.id");
	while ( $obj=DB_ROWOBJ($r) ) {
		if ( strlen($obj->id) ) continue;
		++$cnt;
		$msg = new fud_msg_edit;
		$msg->get_by_id($obj->msg_id);
		$msg->delete();
		unset($msg);
	}
	QF($r);
	draw_info($cnt);
	
	draw_stat('Checking smileys against disk files');
	$cnt = 0;
	$r = Q("SELECT * FROM fud_smiley"); 
	$smiley_dsk  = $GLOBALS['IMG_ROOT_DISK'].$GLOBALS['SMILEY_DIR'];
	while ( $obj = DB_ROWOBJ($r) ) {
		if ( file_exists($smiley_dsk.$obj->img) ) {
			$smiley_ar[md5($obj->img)] = 1;
			continue;
		}
		++$cnt;
		Q("DELETE FROM fud_smiley WHERE id=".$obj->id);
	}
	draw_info($cnt);

	draw_stat('Checking disk files against smileys');
	$cnt = 0;
	$dp = opendir($smiley_dsk);
	while ( $de = readdir($dp) ) {
		if ( $de == '.' || $de == '..' ) continue;
		if ( !preg_match('!\.(gif|png|jpg|jpeg)$!i', $de) ) continue;
		if ( isset($smiley_ar[md5($de)]) ) continue;
		
		draw_stat("deleting: '".$smiley_dsk.$de."'");
		if ( !@unlink($smiley_dsk.$de) ) {
			++$cnt;
			draw_info('Unable to delete '.$smiley_dsk.$de);
		}
	}
	unset($smiley_ar);
	draw_info($cnt);
	
	draw_stat("Checking Approvals");
	$r = Q("SELECT fud_msg.id FROM fud_thread LEFT JOIN fud_forum ON fud_thread.forum_id=fud_forum.id LEFT JOIN fud_msg ON fud_thread.id=fud_msg.thread_id WHERE fud_forum.moderated='N' AND fud_msg.approved='N'");
	if( DB_COUNT($r) ) {
		while ( list($id) = DB_ROWARR($r) ) {
			Q("UPDATE fud_msg SET approved='Y' WHERE id=".$id);
		}
	}
	draw_stat("Done: Checking Approvals");
	
	/* fixing counts */
	draw_stat('Updating counts for threads');
	$result = Q("SELECT fud_thread.id AS th_id, fud_forum.moderated FROM fud_thread LEFT JOIN fud_forum ON fud_thread.forum_id=fud_forum.id");
	while ( $obj = DB_ROWOBJ($result) ) {
		if ( $obj->moderated == 'Y' ) 
			$q = "SELECT count(*) FROM fud_msg WHERE thread_id=".$obj->th_id." AND approved='Y'";
		else
			$q = "SELECT count(*) FROM fud_msg WHERE thread_id=".$obj->th_id;
			
		$r = Q($q);
		list($post_count) = DB_ROWARR($r);
		Q("UPDATE fud_thread SET replies=".$post_count."-1 WHERE id=".$obj->th_id);
		QF($r);
	}
	draw_stat('threads updated');

	draw_stat('Updating forums');
	$result = Q("SELECT * FROM fud_forum");
	draw_stat('Updating thread counts for forums');
	while ( $obj = DB_ROWOBJ($result) ) {
		draw_stat('Forum: '.$obj->name);
		if ( $obj->moderated == 'Y' ) {
			$qth = "SELECT count(*) FROM fud_thread LEFT JOIN fud_msg ON fud_thread.root_msg_id=fud_msg.id WHERE forum_id=".$obj->id." AND fud_msg.approved='Y'";
			$qp = "SELECT count(*) FROM fud_thread RIGHT JOIN fud_msg ON fud_msg.thread_id=fud_thread.id WHERE fud_thread.forum_id=$obj->id AND fud_msg.approved='Y'";
		}
		else {
			$qth = "SELECT count(*) FROM fud_thread WHERE forum_id=".$obj->id;
			$qp = "SELECT count(*) FROM fud_thread RIGHT JOIN fud_msg ON fud_msg.thread_id=fud_thread.id WHERE fud_thread.forum_id=".$obj->id;
		}
		
		$th_count = Q_SINGLEVAL($qth);
		$p_count = Q_SINGLEVAL($qp);
			
		draw_stat('thread count:'.$th_count);
		draw_stat('post count:'.$p_count);
		Q("UPDATE fud_forum SET thread_count=".$th_count.", post_count=".$p_count." WHERE id=".$obj->id);
	}
	QF($result);
	draw_stat('Updating post counts');
	draw_stat('finished forum counts');
	
	/* thread notif */
	draw_stat('Checking thread notification entires against users');
	$cnt = 0;
	$result = Q("SELECT fud_thread_notify.id, fud_users.id AS reg_user_id FROM fud_thread_notify LEFT JOIN fud_users ON fud_thread_notify.user_id=fud_users.id");
	while ( $obj = DB_ROWOBJ($result) ) {
		if ( !strlen($obj->reg_user_id) ) {
			Q("DELETE FROM fud_thread_notify WHERE id=".$obj->id);
			++$cnt;
		}
	}
	
	QF($result);
	draw_info($cnt);

	draw_stat('Checking thread notifiction entries against threads');
	$cnt = 0;
	$result = Q("SELECT fud_thread_notify.id FROM fud_thread_notify LEFT JOIN fud_thread ON fud_thread_notify.thread_id=fud_thread.id WHERE fud_thread.id IS NULL");
	while ( $obj = DB_ROWOBJ($result) ) {
		Q("DELETE FROM fud_thread_notify WHERE id=".$obj->id);
		++$cnt;
	}
	QF($result);
	draw_info($cnt);
	
	/* forum notif */
	draw_stat('Checking forum notification entires against users');
	$cnt = 0;
	$result = Q("SELECT fud_forum_notify.id, fud_users.id AS reg_user_id FROM fud_forum_notify LEFT JOIN fud_users ON fud_forum_notify.user_id=fud_users.id WHERE fud_users.id IS NULL");
	while ( $obj = DB_ROWOBJ($result) ) {
		Q("DELETE FROM fud_forum_notify WHERE id=".$obj->id);
		++$cnt;
	}
	
	QF($result);
	draw_info($cnt);

	draw_stat('Checking forum notifiction entries against forums');
	$cnt = 0;
	$result = Q("SELECT fud_forum_notify.id FROM fud_forum_notify LEFT JOIN fud_forum ON fud_forum_notify.forum_id=fud_forum.id WHERE fud_forum.id IS NULL");
	while ( $obj = DB_ROWOBJ($result) ) {
		Q("DELETE FROM fud_forum_notify WHERE id=".$obj->id);
		++$cnt;
	}
	QF($result);
	draw_info($cnt);
	
	draw_stat('Updating Thread Last_Post_Id Field');
	$r = Q("SELECT fud_thread.id,MAX(fud_msg.id) AS mid,fud_msg.post_stamp FROM fud_thread LEFT JOIN fud_msg ON fud_thread.id=fud_msg.thread_id WHERE fud_msg.approved='Y' GROUP BY fud_msg.thread_id");
	if( DB_COUNT($r) ) {
		while ( $obj = DB_ROWOBJ($r) ) {
			Q("UPDATE fud_thread SET last_post_id=".$obj->mid.",last_post_date=".$obj->post_stamp." WHERE id=".$obj->id);
		}
	}
	draw_stat('Done: Updating Thread Last_Post_Id Field');
	
	draw_stat('Updating Forum Last_Post_Id Field');
	$r = Q("SELECT id FROM fud_forum");
	while( list($forum_id) = DB_ROWARR($r) ) {
		$last_post_id = Q_SINGLEVAL("SELECT last_post_id FROM fud_thread INNER JOIN fud_msg ON fud_thread.last_post_id=fud_msg.id WHERE forum_id=".$forum_id." AND fud_msg.approved='Y' ORDER BY last_post_id DESC LIMIT 1");
		if( !$last_post_id ) $last_post_id=0;
		Q("UPDATE fud_forum SET last_post_id=".$last_post_id." WHERE id=".$forum_id); 
	}
	QF($r);	
	draw_stat('Done: Updating Forum Last_Post_Id Field');
	
	draw_stat('Checking email notification entires against threads');
	$cnt = 0;
	$result = Q("SELECT fud_thread_notify.id, fud_thread.id AS th_id FROM fud_thread_notify LEFT JOIN fud_thread ON fud_thread_notify.thread_id=fud_thread.id");
	while ( $obj = DB_ROWOBJ($result) ) {
		if ( !strlen($obj->th_id) ) {
			Q("DELETE FROM fud_thread_notify WHERE id=".$obj->id);
			++$cnt;
		}
	}
	QF($result);
	draw_info($cnt);
	
	draw_stat('Checking thread votes against threads');
	$cnt = 0;
	$r=Q("SELECT fud_thread_rate_track.id FROM fud_thread_rate_track LEFT JOIN fud_thread ON fud_thread_rate_track.thread_id=fud_thread.id WHERE fud_thread.id IS NULL");
	while ( $obj = DB_ROWOBJ($r) ) {
		++$cnt;
		Q("DELETE FROM fud_thread_rate_track WHERE id=".$obj->id);
	}
	QF($r);
	draw_info($cnt);
	
	
	draw_stat('Checking thread votes against users');
	$cnt = 0;
	$r=Q("SELECT fud_thread_rate_track.id FROM fud_thread_rate_track LEFT JOIN fud_users ON fud_thread_rate_track.user_id=fud_users.id WHERE fud_users.id IS NULL");
	while ( $obj = DB_ROWOBJ($r) ) {
		++$cnt;
		Q("DELETE FROM fud_thread_rate_track WHERE id=".$obj->id);
	}
	QF($r);
	draw_info($cnt);
	
	draw_stat('Updating thread vote counts');
	$cnt = 0;
	$r = Q("SELECT fud_thread.id, ROUND(AVG(fud_thread_rate_track.rating)) as avg_rating FROM fud_thread LEFT JOIN fud_forum ON fud_thread.forum_id=fud_forum.id AND fud_forum.allow_user_vote='Y' LEFT JOIN fud_thread_rate_track ON fud_thread_rate_track.thread_id=fud_thread.id GROUP BY fud_thread_rate_track.thread_id");
	while ( $obj = DB_ROWOBJ($r) ) {
		++$cnt;
		if ( !strlen($obj->avg_rating) ) $obj->avg_rating = 0;
		Q("UPDATE fud_thread SET rating=".$obj->avg_rating." WHERE id=".$obj->id);
	}
	QF($r);
	draw_stat($cnt.' threads updated');
	
	draw_stat('Rebuilding Thread Views');
	Q("DELETE FROM fud_thread_view");
	$tm=time();
	$fr = Q("SELECT id FROM fud_forum");
	while ( list($frm_id) = DB_ROWARR($fr) ) {
		$vlist = '';
	
		$r = Q("SELECT 
			fud_thread.id, 
			fud_thread.forum_id,
			IF(is_sticky='Y' AND (fud_msg.post_stamp+fud_thread.orderexpiry>".$tm." OR fud_thread.orderexpiry=0), 4200000000, fud_thread.last_post_id) AS sort_order_fld
		FROM 
			fud_thread
			INNER JOIN fud_msg
				ON fud_thread.root_msg_id=fud_msg.id
		WHERE 
			forum_id=".$frm_id."
		ORDER BY 
			sort_order_fld DESC,
			fud_thread.last_post_date DESC
		");

		$i = 0;
		$cnt = 0;
		$page = 1;
		while ( $obj = DB_ROWOBJ($r) ) {
			if ( $i && !($i%$GLOBALS['THREADS_PER_PAGE']) ) {
				$vlist = substr($vlist, 0, -2);
				Q("INSERT INTO fud_thread_view (page, forum_id, thread_id, pos) VALUES $vlist");
				$vlist = '';
				$page++;
				$cnt = 0;
			}	
			
			$vlist .= "($page, $obj->forum_id, $obj->id, ".++$cnt."),\n";
			$i++;
		}
		if ( strlen($vlist) ) {
			$vlist = substr($vlist, 0, -2);
			Q("INSERT INTO fud_thread_view (page, forum_id, thread_id, pos) VALUES $vlist");
		}
		QF($r);	
	}
	QF($fr);
	draw_stat('Done Rebuilding Thread Views');
	
	draw_stat('Rebuilding user levels & message counts');
	$r = Q(" SELECT fud_users.id, count(fud_msg.id) AS cnt FROM fud_users LEFT JOIN fud_msg ON fud_users.id=fud_msg.poster_id AND fud_msg.approved='Y' GROUP BY fud_users.id");
	while( $obj = DB_ROWOBJ($r) ) {
		$level_id = Q_SINGLEVAL("SELECT id FROM fud_level WHERE post_count<=".$obj->cnt." ORDER BY post_count DESC LIMIT 1");
		if( !$level_id ) $level_id=0;
		Q("UPDATE fud_users SET posted_msg_count=".$obj->cnt.",level_id=".$level_id." WHERE id=".$obj->id);
	}
	QF($r);
	draw_stat('Done rebuilding user levels & message counts');
	
	draw_stat('Rebuilding custom user statuses');
	$c_level = new fud_custom_tag;
	$r = Q("SELECT distinct(user_id) FROM fud_custom_tags");
	while( list($c_level->user_id) = DB_ROWARR($r) ) {
		$c_level->sync();
	}
	draw_stat('Done Rebuilding custom user statuses');

	$cnt = 0;
	draw_stat('Checking buddies against entry owners');
	$r = Q("SELECT fud_buddy.id FROM fud_buddy LEFT JOIN fud_users ON fud_buddy.user_id=fud_users.id WHERE fud_users.id IS NULL");
	while ( $obj = DB_ROWOBJ($r) ) {
		Q("DELETE FROM fud_buddy WHERE id=".$obj->id);
		++$cnt;
	}
	QF($r);
	draw_info($cnt);
	
	$cnt = 0;
	draw_stat('Checking buddies against users');
	$r = Q("SELECT fud_buddy.id FROM fud_buddy LEFT JOIN fud_users ON fud_buddy.bud_id=fud_users.id WHERE fud_users.id IS NULL");
	while ( $obj = DB_ROWOBJ($r) ) {
		Q("DELETE FROM fud_buddy WHERE id=".$obj->id);
		++$cnt;
	}
	QF($r);
	draw_info($cnt);
	
	$cnt = 0;
	draw_stat('Checking ignore list against entry owners');
	$r = Q("SELECT fud_user_ignore.id FROM fud_user_ignore LEFT JOIN fud_users ON fud_user_ignore.user_id=fud_users.id WHERE fud_users.id IS NULL");
	while ( $obj = DB_ROWOBJ($r) ) {
		Q("DELETE FROM fud_buddy WHERE id=".$obj->id);
		++$cnt;
	}
	QF($r);
	draw_info($cnt);
	
	$cnt = 0;
	draw_stat('Checking ignore list against users');
	$r = Q("SELECT fud_user_ignore.id FROM fud_user_ignore LEFT JOIN fud_users ON fud_user_ignore.ignore_id=fud_users.id WHERE fud_users.id IS NULL");
	while ( $obj = DB_ROWOBJ($r) ) {
		Q("DELETE FROM fud_buddy WHERE id=".$obj->id);
		++$cnt;
	}
	QF($r);
	draw_info($cnt);
	
	draw_stat('Rebuild File Extension Filter');
	$ext = new fud_ext_block;
	$ext->mk_regexp();
	draw_stat('Done: Rebuilding File Extension Filter');
	
	draw_stat('Unlocking database');
	DB_UNLOCK();	
	draw_stat('Database unlocked');

	if( $GLOBALS['FORUM_ENABLED'] == 'Y' ) {
		draw_stat('Re-enabling the forum.');
		maintenance_status($GLOBALS['DISABLED_REASON'], 'Y');
	}
	else {
		echo '<font size=+1 color="red">Your forum is currently disabled, to re-enable it go to the <a href="admglobal.php?'.$_RSID.'">Global Settings Manager</a> and re-enable it.</font>';
	}

	draw_stat('DONE');
	
	readfile('admclose.html');
?>