<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: register.php,v 1.21 2002/02/12 19:55:18 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/

/*#? Register Page */
	include_once "GLOBALS.php";
	
	$GLOBALS['USER_REG'] = 1;
	
	fud_use('error.inc');
	fud_use('db.inc');
	fud_use('users.inc');
	fud_use('email.inc');
	fud_use('widgets.inc');
	fud_use('cookies.inc');
	fud_use('url.inc');
	fud_use('login.inc');
	fud_use('style.inc');
	fud_use('avatar.inc');
	fud_use('tz.inc');
	fud_use('post.inc');
	fud_use('smiley.inc');
	fud_use('objutil.inc');
	fud_use('fileio_reg.inc');
	fud_use('wordwrap.inc');
	fud_use('post_opt.inc');
	fud_use('rev_fmt.inc');
	
	if( empty($coppa) ) $coppa = NULL;
	if( empty($reg_coppa) ) $reg_coppa = $coppa;
	if( empty($id) ) $id = NULL;

	cache_buster();
	
/*
 * REGISTRATION ERROR CHECK FUNCTIONS
 * This function checks the errors on the register form
 */

function register_form_check($user_id)
{
	if( empty($GLOBALS['error']) ) $GLOBALS['error'] = 0;

	/* General clean up */
	$GLOBALS['HTTP_POST_VARS']['reg_icq'] = ereg_replace('[^0-9]', '', $GLOBALS['HTTP_POST_VARS']['reg_icq']);
	if( isset($GLOBALS['HTTP_POST_VARS']['reg_plaintext_passwd']) ) 
		$GLOBALS['HTTP_POST_VARS']['reg_plaintext_passwd'] = trim($GLOBALS['HTTP_POST_VARS']['reg_plaintext_passwd']);
	if( isset($GLOBALS['HTTP_POST_VARS']['reg_plaintext_passwd']) )
		$GLOBALS['HTTP_POST_VARS']['reg_plaintext_passwd_conf'] = trim($GLOBALS['HTTP_POST_VARS']['reg_plaintext_passwd_conf']);
	$GLOBALS['HTTP_POST_VARS']['reg_name'] = trim($GLOBALS['HTTP_POST_VARS']['reg_name']);
	$GLOBALS['HTTP_POST_VARS']['reg_email'] = trim($GLOBALS['HTTP_POST_VARS']['reg_email']);
	$GLOBALS['HTTP_POST_VARS']['reg_login'] = trim($GLOBALS['HTTP_POST_VARS']['reg_login']);
	$GLOBALS['HTTP_POST_VARS']['reg_home_page'] = trim(url_check($GLOBALS['HTTP_POST_VARS']['reg_home_page']));
	
	if ( strlen($GLOBALS['HTTP_POST_VARS']['reg_avatar_loc']) && !preg_match('!^http://!i', $GLOBALS['HTTP_POST_VARS']['reg_avatar_loc']) )
		$GLOBALS['HTTP_POST_VARS']['reg_avatar_loc'] = 'http://'.$GLOBALS['HTTP_POST_VARS']['reg_avatar_loc'];
	
	/* Check login length */
	if( !$user_id && strlen($GLOBALS['HTTP_POST_VARS']['reg_login']) < 4 ) {
		set_err('reg_login', 'Login you have selected is too short. Login must be at least 4 characters long');
	}
	
	/*
	 * IF we do not have an ID that means that this is a NEW user 
	 * registration
	 */
	if( !$user_id ) {
		if ( is_blocked_login($GLOBALS['HTTP_POST_VARS']['reg_login']) ) {
			set_err('reg_login', 'This login name is not allowed');
		}
	
		/* Login uniqness check */
		if ( get_id_by_login($GLOBALS['HTTP_POST_VARS']['reg_login']) ) {
			set_err('reg_login', 'Forum login names must be unique, there is already a user with such a name present on the system');
		}
		
		if ( get_id_by_email($GLOBALS['HTTP_POST_VARS']['reg_email']) ) {
			set_err('reg_email', 'This email already exists, if you have forgoten your password please use the restore option, instead of re-registering');
		}
		
		if( strlen($GLOBALS['HTTP_POST_VARS']["reg_plaintext_passwd"]) < 6 ) {
			set_err('reg_plaintext_passwd', 'The password must be at least 6 characters long');
		}
	}
	
	/* Password check, needs to be done only if registering a new user */
	if( !$user_id && $GLOBALS['HTTP_POST_VARS']["reg_plaintext_passwd"] != $GLOBALS['HTTP_POST_VARS']["reg_plaintext_passwd_conf"] ) {
		set_err('reg_plaintext_passwd', 'Your passwords do not match.');
	}
	
	/* E-mail validity check */
	if( validate_email($GLOBALS['HTTP_POST_VARS']["reg_email"]) ) {
		set_err('reg_email', 'The e-mail address you have specified does not appear to be valid.');
	}
	
	/* User's name or nick name */
	if( strlen($GLOBALS['HTTP_POST_VARS']["reg_name"]) < 2 ) {
		set_err('reg_name', 'To successfuly complete this registration you must enter your name.');
	}
	
	if ( $user_id ) {
		if ( empty($GLOBALS['mod_id']) ) {
			if ( !check_passwd($user_id, stripslashes($GLOBALS['HTTP_POST_VARS']['reg_confirm_passwd'])) ) {
				set_err('reg_confirm_passwd', 'You must enter your current password to compelete the changes');
			}
		}
		else {
			if ( !check_passwd(1, stripslashes($GLOBALS['HTTP_POST_VARS']['reg_confirm_passwd'])) ) {
				set_err('reg_confirm_passwd', 'You must enter your ADMINISTRATOR password to compelete the changes');
			}
		}
		
		if ( ($email_id=get_id_by_email($GLOBALS['HTTP_POST_VARS']['reg_email'])) && $email_id != $user_id ) {
			set_err('reg_email', 'Some already is registered with this email, and that someone is NOT you');
		}
	}
	
	return $GLOBALS['error'];
}

function set_err($err_name, $err_msg)
{
	$GLOBALS['error'] = 1;
	$GLOBALS['err_msg'][$err_name] = $err_msg;
}

function draw_err($err_name)
{
	if ( !isset($err_name) || !isset($GLOBALS['err_msg'][$err_name]) || !strlen($GLOBALS['err_msg'][$err_name])) return;
	return '<br><font class="ErrorText">'.$GLOBALS['err_msg'][$err_name].'</font>';
}

function clean_variables()
{
	$vars = array('reg_avatar_loc','reg_login','reg_email','reg_name','reg_location','reg_occupation','reg_interests','reg_user_image','reg_icq','reg_aim','reg_yahoo','reg_home_page','reg_msnm','reg_avatar','b_month','b_day','b_year','reg_gender','reg_bio','reg_sig','reg_invisible_mode','reg_notify','reg_notify_method','reg_posts_ppg','reg_style');
	while( list(,$v) = each($vars) ) {
		if( !isset($GLOBALS["HTTP_POST_VARS"][$v]) ) $GLOBALS[$v]=$GLOBALS["HTTP_POST_VARS"][$v]=NULL;		
	}
}

function fmt_post_vars(&$arr, $who, $leave_arr=NULL)
{
	if ( isset($leave_arr) ) {
		reset($leave_arr);
		while ( list(,$v) = each($leave_arr) ) {
			$leave[$v] = 1;
		}
	}

	while( list($k,) = each($arr) ) {
		if ( isset($leave[$k]) ) $GLOBALS['_BK_'][$k] = $arr[$k];
		if ( $who == 'DB' ) 
			$GLOBALS['MYSQL_DATA'][$k] = htmlspecialchars($arr[$k]);
		else 
			$GLOBALS[$k] = $arr[$k] = FMT($arr[$k]);
	}
}
/*
 * END OF ERROR CHECK FUNCTIONS 
 */


	/*----------------- END FORM FUNCTIONS --------------------*/
	list($ses, $usr) = init_user();

	if( empty($usr->id) && empty($reg_coppa) ) {
		if ( $GLOBALS['COPPA'] == 'Y' ) {
			header("Location: coppa.php?".$_RSID);
		}
		else if ( $GLOBALS['COPPA'] != 'Y' ) {
			header("Location: pre_reg.php");	
		}
		exit;
	}	
	
	if( empty($prev_loaded) ) 
		clean_variables();
	else {
		
	}

	/* allow the root to moderate other lusers */
	if ( !empty($usr) && $usr->is_mod == 'A' && $mod_id ) {
		$MOD_usr = new fud_user;
		$MOD_usr->get_user_by_id($usr->id);
		$usr = new fud_user_reg;
		$usr->get_user_by_id($mod_id);
	}
	else $mod_id=NULL;
	
	if ( empty($usr) && $ALLOW_REGISTRATION != 'Y' ) {
		std_error('registration_disabled');
		exit();
	}
	
	/*
	 * deal with attached files
	 */		
	 if ( $GLOBALS['CUSTOM_AVATARS'] == 'UPLOAD' || $GLOBALS['CUSTOM_AVATARS'] == 'BOTH' ) {
		$avatar_arr=NULL;
		if( isset($avatar_tmp) ) {
			$avatar_tmp = base64_decode($avatar_tmp);
			if ( strlen($avatar_tmp) ) {
				list($avatar_arr['file'], $avatar_arr['local'], $avatar_arr['del'], $avatar_arr['leave']) = explode("\n", $avatar_tmp);
			}
		}	
	
		if ( !empty($btn_detach) ) {
			if ( strlen($avatar_arr['file']) ) @unlink($GLOBALS['TMP'].$avatar_arr['file']);
			$avatar_arr['file'] = '';
			$avatar_arr['del'] = 1;
			$avatar_arr['leave'] = 0;
		}
	
		if ( isset($avatar_upload_size) && $avatar_upload_size > 0 ) {
			if( $avatar_upload_size>=$GLOBALS['CUSTOM_AVATAR_MAX_SIZE'] ) { 
				set_err('avatar','The file you are trying to upload is too big, over '.$GLOBALS['CUSTOM_AVATAR_MAX_SIZE'].' byte limit');
			}
			else if( preg_match('!\.(jpg|jpeg|gif|png)$!i', $avatar_upload_name) ) {
				if ( strlen($avatar_arr['file']) ) @unlink($GLOBALS['TMP'].$avatar_arr['file']);
				$avatar_arr['file'] = safe_tmp_copy($avatar_upload);
				$avarar_arr['del'] = 0;
				$avatar_arr['leave'] = 0;
			}
			else {
				set_err('avatar','The file you are trying to upload is not allowed');
			}	
		}
	}
	
	/*
	 * SUBMITTION CODE
	 *
	 * Here we submit the form, if it passes the error check
	 * then we actually do it, what is done depends
	 * wether we are registering as a new user
	 * or updating a profile
	 */
	
	if ( !empty($fud_submit) && !register_form_check($usr->id) ) {
		fmt_post_vars($HTTP_POST_VARS, 'DB', array('reg_sig'));
	
		reverse_FMT($GLOBALS['MYSQL_DATA']['reg_sig']);
		$reg_sig = apply_custom_replace($GLOBALS['MYSQL_DATA']['reg_sig']);
		
		$HTTP_POST_VARS['reg_bday'] = fmt_year($b_year).prepad($b_month, 2, '0').prepad($b_day, 2, '0');
		
		switch ( strtolower($GLOBALS['FORUM_CODE_SIG']) )
		{
			case 'ml':
				$reg_sig = tags_to_html($reg_sig, $GLOBALS['FORUM_IMG_SIG']);
				break;
			case 'html':
				break;
			default:
				$reg_sig = nl2br(htmlspecialchars($reg_sig));				       
		}
		
		if ( strtolower($GLOBALS['FORUM_SML_SIG']) == 'y' ) smiley_to_post($reg_sig);
		
		$reg_sig = stripslashes($reg_sig);
		fud_wordwrap($reg_sig);
		$reg_sig = addslashes($reg_sig);
		
		if( empty($usr->id) ) $usr = new fud_user_reg;
		
		fetch_vars("reg_", $usr, $GLOBALS['MYSQL_DATA']);
		$usr->sig = $reg_sig;		
		$usr->bio = stripslashes($usr->bio);
		$usr->home_page = stripslashes($usr->home_page);
	
		if( empty($usr->id) ) {
			
			$usr->login = stripslashes($usr->login);
			reverse_FMT($usr->login);
			$usr->login = addslashes($usr->login);
			
			$usr->plaintext_passwd = stripslashes($usr->plaintext_passwd);
			reverse_FMT($usr->plaintext_passwd);

			$usr->id = $usr->add_user();
			
			if ( !isset($ses) ) $ses = new fud_session;
			$ses->putvar('user_id', $usr->id);
			$ses->save_session($usr->id);
			
			if ( $GLOBALS['CUSTOM_AVATARS'] == 'UPLOAD' || $GLOBALS['CUSTOM_AVATARS'] == 'BOTH' ) { 
				if ( strlen($avatar_arr['file']) ) {
					copy($GLOBALS['TMP'].$avatar_arr['file'], $GLOBALS['IMG_ROOT_DISK'].$GLOBALS['CUSTOM_AVATAR_DIR'].$usr->id);
					chmod($GLOBALS['IMG_ROOT_DISK'].$GLOBALS['CUSTOM_AVATAR_DIR'].$usr->id,0644);
				}	
			}
			
			if ( $GLOBALS['EMAIL_CONFIRMATION'] == 'Y' ) {
				$conf_body = read_email_message('confirmation.msg', array("url"=>$GLOBALS['WWW_ROOT']."emailconf.php?conf_key=".$usr->conf_key));
				send_email($GLOBALS['NOTIFY_FROM'], $usr->email, "Registation Confirmation", $conf_body, "");
			}
			else {
				$conf_body = read_email_message('joining.msg', array("url"=>$GLOBALS['WWW_ROOT'],"login"=>$usr->login, "password"=>$HTTP_POST_VARS['reg_plaintext_passwd'],"profile"=>"http://".$GLOBALS['WWW_ROOT']."/register.php"));
				send_email($GLOBALS['NOTIFY_FROM'], $usr->email, "Forum Registration Confirmation", $conf_body, "");
			}
			
			if ( $GLOBALS['COPPA'] == 'Y' && strtolower($reg_coppa) == 'y' ) {
				header("Location: coppa_fax.php?".$_RSID);
				exit();
			}
			check_return();
		}
		else if ( !empty($usr->id) ) {
			$user_avatar_file = $GLOBALS['IMG_ROOT_DISK'].$GLOBALS['CUSTOM_AVATAR_DIR'].$usr->id;
			
			if ( $avatar_type == 'b' ) {
				if ( $usr->avatar_loc )
					$usr->avatar_loc = '';
				else if ( $usr->avatar_approved == 'Y' )
					@unlink($user_avatar_file);
				$usr->avatar_approved = 'NO';	
			}
			else if ( strlen($reg_avatar_loc) ) {
				if ( $usr->avatar_loc != $reg_avatar_loc ) {
					$usr->avatar_loc = $reg_avatar_loc;
					$usr->avatar_approved='N';
				}
				
				if ( file_exists($user_avatar_file) ) {
					@unlink($user_avatar_file);
				}
			}
			else if ( strlen($avatar_arr['file']) && $avatar_arr['leave'] < 1 && $avatar_arr['del'] < 1 ) {
				copy($GLOBALS['TMP'].$avatar_arr['file'], $user_avatar_file);
				chmod($user_avatar_file,0644);
				$usr->avatar_approved='N';
				$usr->avatar_loc = '';
			}
			else if ( $avatar_arr['del'] > 0 ) {
				if ( file_exists($user_avatar_file) ) @unlink($user_avatar_file);
				$usr->avatar_loc = '';
				$usr->avatar_approved = 'NO';
			}
			else if( $avatar_arr['leave'] > 0 ) {
				$avatar_approved = Q_SINGLEVAL("SELECT avatar_approved FROM fud_users WHERE id=".$usr->id);
			}	
			
			$usr->sync_user();
			
			if( $avatar_arr['file'] && file_exists($GLOBALS['TMP'].$avatar_arr['file']) && is_file($GLOBALS['TMP'].$avatar_arr['file']) ) 
				unlink($GLOBALS['TMP'].$avatar_arr['file']);
			
			/* restore admin for the redirect */
			$usr = $MOD_usr;
			check_return();
		}
		else {
			error_dialog('ERROR: unable to register', 'Unable to create user account, please contant the administrator at <a href="mailto:'.$ADMIN_EMAIL.'">'.$ADMIN_EMAIL.'</a>', '', 'FATAL');
			exit();
		}
	}
	
	fmt_post_vars($HTTP_POST_VARS, 'FORM', array('reg_sig','avatar_tmp'));
/*
 * If we have an id we're trying to update the users profile
 * this bit of code will export the varibles for the form
 */	
	if( !empty($usr->id) && empty($prev_loaded) && empty($forced_new_reg) ) {
		export_vars("reg_",$usr);
		
		reverse_FMT($GLOBALS['reg_sig']);
		
		$GLOBALS['reg_sig'] = apply_reverse_replace($GLOBALS['reg_sig']);
		
		if ( strtolower($GLOBALS['FORUM_SML_SIG']) == 'y' ) 
			$GLOBALS['reg_sig'] = post_to_smiley($GLOBALS['reg_sig']);
		
		switch ( strtolower($GLOBALS['FORUM_CODE_SIG']) )
		{
			case 'ml':
				$GLOBALS['reg_sig'] = html_to_tags($GLOBALS['reg_sig']);
				break;
			case 'html':
				break;
			default:
				reverse_nl2br($GLOBALS['reg_sig']);
		}
		
		$b_year = substr($reg_bday, 0, 4);
		$b_month = substr($reg_bday, 4, 2);
		$b_day = substr($reg_bday, 6, 8);
		if ( file_exists($GLOBALS['IMG_ROOT_DISK'].$GLOBALS['CUSTOM_AVATAR_DIR'].$usr->id) ) {
			$avatar_type = 'u';
			$avatar_arr['leave'] = 1;
		}
		else if ( $usr->avatar_loc ) {
			$reg_avatar_loc = $usr->avatar_loc;
			$avatar_type = 'c';
		}
		
		if ( strlen($usr->avatar) ) {
			$reg_avatar_img = Q_SINGLEVAL("SELECT img FROM fud_avatar WHERE id=".$usr->avatar);
			$reg_avatar_img = $GLOBALS['WWW_ROOT'].$GLOBALS['IMG_ROOT_WWW'].$GLOBALS['AVATAR_DIR'].$reg_avatar_img;
		}
	}

/*
 * If this is users first vist to the registration form setup the
 * default values
 */
	if ( empty($GLOBALS['id']) && empty($error) ) {
		$reg_display_email = 'Y';
		$notify = 'N';
		$reg_ignore_admin = 'N';
		$reg_private_messages = 'Y';	
		$reg_append_sig = 'Y';
		$reg_show_sigs = 'Y';
		$reg_show_tool_tips = 'N';
		$reg_invisible_mode = 'N';
		$reg_notify = 'Y';
		$default_view = $GLOBALS['DEFAULT_THREAD_VIEW'];
	}
	
	if ( empty($reg_time_zone) ) $reg_time_zone = $GLOBALS['SERVER_TZ'];
	
	set_row_color_alt(true);

	if ( isset($ses) && isset($usr) ) 
		$ses->update('Viewing own profile');
	else 
		$ses->update('Registration Page');

	$TITLE_EXTRA = ': Register';
	$layout = get_layout_id((isset($layout)?$layout:'')); include_once $GLOBALS['FORUM_SETTINGS_PATH'].'header_'.$layout.'.inc';

	if( isset($usr) && empty($mod_id) ) fud_use('usroptions.inc');

	lay_start_content_table();

	echo '<tr class="TableHeading"><td colspan=2 class="TableHeading"><b>Required Information</b><br><font class="SmallText">All fields are required.  Please note that passwords are case sensitive.</font></td></tr>';
	echo '<form method="post" action="register.php" name="fud_register" enctype="multipart/form-data">';

if( empty($usr->id) ) {
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Login:'.draw_err('reg_login').'</td><td><input type="text" size=25 name="reg_login" value="'.$reg_login.'" maxLength=50></td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Password:'.draw_err('reg_plaintext_passwd').'</td><td><input type="password" name="reg_plaintext_passwd" size=25 maxlength=16></td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Confirm Password:</td><td><input type="password" name="reg_plaintext_passwd_conf" size=25 maxlength=16></td></tr>';	
} else { 
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Login:'.draw_err('reg_login').'</td><td class="GenText"><b>'.htmlspecialchars($usr->login).'</b></td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Your Password:'.draw_err('reg_confirm_passwd').'</td><td><input type="password" name="reg_confirm_passwd" size=25 maxlength=16>'.(empty($mod_id)?' <font class="SmallText">[ <a href="#" onClick="javascript:window_open(\'rpasswd.php?'.$_RSID.'\',\'rpass\',380,250);" class="GenLink">change password</a> ]</font>':'').'</td></tr>';
}
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Email:'.draw_err('reg_email').'<br><font class="SmallText">Please enter a valid email address. You can choose to hide it below in the preferences section.</font></td><td><input type="text" name="reg_email" size=25 value="'.$reg_email.'"></td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Name:'.draw_err('reg_name').'</td><td><input type="text" name="reg_name" size=25 value="'.$reg_name.'"></td></tr>';
if( isset($usr) ) {
	echo '<tr'.ROW_BGCOLOR().'><td align="center" colspan=2 class="GenText"><input type="submit" name="fud_submit" value="Update"></td></tr>';
}
	echo '<tr class="TableHeading"><td colspan=2 class="TableHeading"><b>Optional Information</b><br><font class="SmallText">It is recommended that you do not reveal any personally identifying information in your profile.  All information will be viewable by other forum members.</font></td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Location:</td><td><input type="text" name="reg_location" value="'.$reg_location.'"maxlength=255 size=30></td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Occupation:</td><td><input type="text" name="reg_occupation" value="'.$reg_occupation.'"maxlength=255 size=30></td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Interests:</td><td><input type="text" name="reg_interests" value="'.$reg_interests.'"maxlength=255 size=30></td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Image:</td><td><input type="text" name="reg_user_image" value="'.$reg_user_image.'"maxlength=255 size=30></td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">ICQ Number:</td><td><input type="text" name="reg_icq" value="'.$reg_icq.'" maxLength=32 size=25></td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">AIM Handle:</td><td><input type="text" name="reg_aim" value="'.$reg_aim.'" maxLength=32 size=25></td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Yahoo Messenger:</td><td><input type="text" name="reg_yahoo" value="'.$reg_yahoo.'" maxLength=32 size=25></td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">MSN Messenger:</td><td><input type="text" name="reg_msnm" value="'.$reg_msnm.'" maxLength=32 size=25></td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Homepage:</td><td><input type="text" name="reg_home_page" value="'.$reg_home_page.'" maxLength=255></td></tr>';

	$avt = new fud_avatar;
	if( ($avtc=$avt->avt_count()) || $GLOBALS['CUSTOM_AVATARS']!='OFF' ) {
		if ( $avtc < 1 && $GLOBALS['CUSTOM_AVATARS']!='OFF' ) $avatar_type = 'u';
		if ( $reg_avatar ) {
			$avt->get($reg_avatar);
			$reg_avatar_img = $GLOBALS['WWW_ROOT'].$GLOBALS['IMG_ROOT_WWW'].$GLOBALS['AVATAR_DIR'].$avt->img;
		}
		else $reg_avatar_img = 'blank.gif';
		
		if ( empty($avatar_type) || !strlen($GLOBALS['CUSTOM_AVATARS']) || $GLOBALS['CUSTOM_AVATARS']=='OFF' ) $avatar_type = 'b';
		
		if ( $GLOBALS['CUSTOM_AVATARS'] == 'BOTH' && isset($usr) ) {
			$sel_opt = "Built In\nSpecify URL\nUpload Avatar";
			$sel_val = "b\nc\nu";
			$c_a = 1;
		}
		else if ( $GLOBALS['CUSTOM_AVATARS'] == 'URL' && isset($usr) ) {
			$sel_opt = "Built In\nSpecify URL";
			$sel_val = "b\nc";
			$c_a = 1;
		}
		else if ( $GLOBALS['CUSTOM_AVATARS'] == 'UPLOAD' && isset($usr) ) {
			$sel_opt = "Built In\nUpload Avatar";
			$sel_val = "b\nu";
			$c_a = 1;
		}
		
		if ( isset($c_a) ) 
			echo '<tr'.ROW_BGCOLOR().' valign="top"><td class="GenText" colspan>Avatar Type:</td><td>'.create_select('avatar_type', $sel_opt, $sel_val, $avatar_type, 'onChange="javascript: document.fud_register.submit();"').'</td></tr>';

		if ( $avatar_type == 'b' ) {		
			echo '<tr'.ROW_BGCOLOR().' valign="top"><td class="GenText">Avatar:</td><td class="GenText"><img src="'.$reg_avatar_img.'" border=0 name="reg_avatar_img" value="0"><input type="hidden" name="reg_avatar" value="'.$reg_avatar.'">[<a class="GenLink" href="javascript: window_open(\'avatarsel.php?'.$_RSID.'\', \'avtsel\', 400, 300);">SELECT AVATAR</a>]';
			if ( $reg_avatar ) echo '[<a href="javascript: document.reg_avatar_img.src=\'blank.gif\'; document.fud_register.reg_avatar.value=\'0\'; document.fud_register.submit();" class="GenLink">DELETE AVATAR</a>]';
			echo '<br></td></tr>';
		}
		else if ( $avatar_type == 'c' ) {
			echo '<tr'.ROW_BGCOLOR().' valign="top"><td class="GenText" colspan=2>The custom avatar will not appear until it is approved by the administrator.<br><font class="SmallText">The avatar, should be no larger then <b>'.$GLOBALS['CUSTOM_AVATAR_MAX_DIM'].' pixels</b> and must be in <b>jpg</b> , <b>gif</b> or <b>png</b> format.</font></td></tr>';
			echo '<tr'.ROW_BGCOLOR().' valign="top"><td class="GenText">Custom Avatar URL</td><td><input type="text" value="'.$reg_avatar_loc.'" name="reg_avatar_loc"></td></tr>';
		}
		else if ( $avatar_type == 'u' ) {
			echo '<tr'.ROW_BGCOLOR().' valign="top"><td class="GenText" colspan=2>The custom avatar will not appear until it is approved by the administrator.<br><font class="SmallText">The avatar, should be no larger then <b>'.$GLOBALS['CUSTOM_AVATAR_MAX_DIM'].' pixels</b> and must be in <b>jpg</b> , <b>gif</b> or <b>png</b> format.</font></td></tr>';
			echo '<tr'.ROW_BGCOLOR().' valign="top"><td class="GenText">Custom Avatar File'.draw_err('avatar').'</td><td>
				<table border=0 cellspacing=0 cellpadding=0>
				<tr>
				<td>';
			
			if ( $avatar_arr['leave'] > 0 ) {
				if ( file_exists($GLOBALS['IMG_ROOT_DISK'].$GLOBALS['CUSTOM_AVATAR_DIR'].$usr->id) ) {
					$avatar_img = $GLOBALS['IMG_ROOT_WWW'].$GLOBALS['CUSTOM_AVATAR_DIR'].$usr->id;
				}
				else $avatar_img = 'blank.gif';
			}
			else if( $avatar_arr['file'] ) 
				$avatar_img = 'tmp_view.php?img='.$avatar_arr['file'];
			else 
				$avatar_img = 'blank.gif';	
			
			echo '  	<img src="'.$avatar_img.'" border=0> 
				</td>
				<td>';
			
			if ( strlen($avatar_arr['file']) || $avatar_arr['leave'] > 0 ) {
				echo '<input type="submit" name="btn_detach" value="Delete Avatar">';
			} else {
				echo '<input type="file" name="avatar_upload"> <input type="submit" name="btn_upload" value="Preview">';
			}
			echo '	</td>
				</tr>
				</table>
			</td></tr>';
			echo '<input type="hidden" name="avatar_tmp" value="'.base64_encode($avatar_arr['file']."\n".$avatar_arr['local']."\n".$avatar_arr['del']."\n".$avatar_arr['leave']).'">';
		}
	}		
	echo '<tr'.ROW_BGCOLOR().' valign="top"><td class="GenText">Birth Date:<br><font class="SmallText">If you select your birthday then other forum members will be able to see it in your profile</font></td><td class="GenText">
		<table border=0 cellspacing=3 cellpadding=0>
			<tr class="GenText">
				<td align="center">Month</td>
				<td align="center">Day</td>
				<td align="center">Year</td>
			</tr>
			<tr>
				<td align="center">'.create_month_select('b_month', TRUE, $b_month).'</td>
				<td align="center">'.create_day_select('b_day', TRUE, $b_day).'</td>
				<td align="center"><input type="text" name="b_year" value="'.$b_year.'" maxLength=4 size=4></td>
				</tr>
			</table></td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Gender:</td><td>'.create_select('reg_gender', "\nMale\nFemale", "\nMALE\nFEMALE", $reg_gender).'</td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText" valign="top">Biography:<br><font class="SmallText">A few details about yourself such as your interests, job, etc...</font></td><td><textarea nowrap name="reg_bio" rows=5 cols=35>'.$reg_bio.'</textarea></td></tr>';

	
	echo '<tr class="TableHeading"><td colspan=2 class="TableHeading"><b>Preferences</b></td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td valign="top" class="GenText">Signature:<br><font class="SmallText">Optional signature you may use to appear at bottom of your posts.<br></font>
		'.post_options('sig').'
		</td><td><textarea nowrap name="reg_sig" rows=5 cols=35>'.$reg_sig.'</textarea></td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Time Zone:</td><td>'.create_timezone_select('reg_time_zone', $reg_time_zone).'</td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Show Tool Tips:<br><font class="SmallText">Allows you to either hide or show other help tool tips.Only works in DOM browsers such as Netscape 6/Mozilla or IE 5+</font></td><td>'.create_radio_buttons('reg_show_tool_tips', "Yes\nNo", "Y\nN", $reg_show_tool_tips, false).'</td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Ignore Administrative Messages:</td><td>'.create_radio_buttons('reg_ignore_admin', "Yes\nNo", "Y\nN", $reg_ignore_admin, false).'</td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Invisible Mode:<br><font class="SmallText">Hides all your personal information from other users.</font></td><td>'.create_radio_buttons('reg_invisible_mode', "Yes\nNo", "Y\nN", $reg_invisible_mode, false).'</td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Show Email Address:<br><font class="SmallText">Choose this option if you want your email address to be publicly displayed.</font></td><td>'.create_radio_buttons('reg_display_email', "Yes\nNo", "Y\nN", $reg_display_email, false).'</td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Select Notification By Default:<br><font class="SmallText">If notification is enabled by default, (can be disabled when posting)</font></td><td>'.create_radio_buttons('reg_notify', "Yes\nNo", "Y\nN", $reg_notify, false).'</td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Choose Notification Method:<br><font class="SmallText">If you would to receive notifications via ICQ please make sure to enable \'EmailExpress\' in your ICQ settings</font></td><td>'.create_select('reg_notify_method', "EMAIL\nICQ", "EMAIL\nICQ", $reg_notify_method,'onChange="javascript: re=/[^0-9]/g; a=document.fud_register.reg_icq.value.replace(re, \'\'); if(this.value==\'ICQ\' && !a.length ) { alert(\'You choose ICQ notification, but did not specify an ICQ #. Defaulting to Email.\'); this.value=\'EMAIL\'; }"').'</td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Allow Private Messages:<br><font class="SmallText">Allow other users to send you e-mails via F.U.D. forum.</font></td><td>'.create_radio_buttons('reg_private_messages', "Yes\nNo", "Y\nN", $reg_private_messages, false).'</td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Use Signature by default:<br><font class="SmallText">Automatically append your signature to every message you post</font></td><td>'.create_radio_buttons('reg_append_sig', "Yes\nNo", "Y\nN", $reg_append_sig, false).'</td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Show Signatures:<br><font class="SmallText">Allows you to either hide or show other forum members signatures</font></td><td>'.create_radio_buttons('reg_show_sigs', "Yes\nNo", "Y\nN", $reg_show_sigs, false).'</td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Messages Per Page:</td><td>'.create_select('reg_posts_ppg', "Use forum default\n5\n10\n20\n30\n40", "0\n5\n10\n20\n30\n40", $reg_posts_ppg).'</td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Default Thread View:</td><td>'.create_select('reg_default_view', "Flat View\nTree View", "msg\ntree", $reg_default_view).'</td></tr>';
	echo '<tr'.ROW_BGCOLOR().'><td class="GenText">Style:</td><td>'.create_style_list('reg_style', $reg_style).'</td></tr>';
?>
<tr>
	<td<?php echo ROW_BGCOLOR(); ?>colspan=2 align="center"><input type="submit" name="fud_submit" value="<?php echo (!empty($usr->id))?'Update':'Register'; ?>">&nbsp;<INPUT TYPE="RESET" NAME="Reset" VALUE="Reset"></td>
	<input type="hidden" name="prev_loaded" value="1">
	<input type="hidden" name="mod_id" value="<?php echo $mod_id; ?>">
	<input type="hidden" name="S" value="<?php echo $S; ?>">
	<input type="hidden" name="reg_coppa" value="<?php echo $reg_coppa; ?>">
	<input type="hidden" name="returnto" value="<?php echo $returnto; ?>">
</tr></form>
<?php
	lay_end_content_table();
	include_once $GLOBALS['FORUM_SETTINGS_PATH'].'footer_'.$layout.'.inc';
?>