<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: cookies.inc,v 1.13 2002/02/12 20:14:02 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/
 if ( defined('_COOKIES_INC_') ) return; else define('_COOKIES_INC_', 1);

	include_once "GLOBALS.php";
	fud_use('db.inc');
	fud_use('util.inc');
	
class fud_session
{
	var $ses_id=NULL;
	var $tm=NULL;
	var $user_id=NULL;
	var $data=NULL;
	var $db_id;
	var $action=NULL;
	var $sys_id=NULL;

	function set_action($str)
	{
		$this->action=$str;
	}

	function update($str='')
	{
		if ( strlen($str) ) $this->set_action($str);
		Q("UPDATE fud_ses SET time_sec=".time().", action=".STRNULL(addslashes($this->action))." WHERE id=".$this->db_id);
	}

	function putvar($name, $val)
	{
		$this->data[$name] = $val;
	}
	
	function getvar($name)
	{
		if ( !isset($this->data[$name]) || !strlen($this->data[$name]) ) return;
		return $this->data[$name];
	}
	
	function rmvar($name)
	{
		unset($this->data[$name]);
	}
	
	function save_session($user_id='',$not_use_cookie='')
	{
		if ( !empty($user_id) ) $this->user_id = $user_id;
		
		$n = count($this->data);
		if( is_array($this->data) ) {
			reset($this->data);
			$db_str = prepad($n, 8, '0');
			while ( list($key, $val) = each($this->data) ) {
				if ( strlen($key) > 10 ) {
					$key = substr($key, 1, 10);
				}
				
				$db_key = prepad($key, 10, ' ');
				$db_len = prepad(strlen($val), 8, '0');
				$db_str .= $db_key.$db_len.$val;
			}
		}
		else $n = 0;
		
		$this->tm = time();
		
		if ( empty($this->db_id) ) {
			DB_LOCK('fud_ses+');
			
			if ( !empty($this->user_id) && $this->user_id<2000000000 ) 
				Q("DELETE FROM fud_ses WHERE user_id=".$this->user_id);
			else {
				$anon_id = Q_SINGLEVAL("SELECT MAX(user_id) FROM fud_ses");
				if( $anon_id < 2000000000 ) $anon_id = 2000000001;
				else $anon_id++;
				
				$this->user_id = $anon_id;
			}

			do {
				$ses_id = md5(get_random_value().get_random_value());
			} while ( BQ("SELECT id FROM fud_ses WHERE ses_id='".$ses_id."'") );
			
			$this->ses_id = $ses_id;
			
			Q("INSERT INTO fud_ses(
				ses_id, 
				time_sec, 
				data, 
				user_id, 
				sys_id) 
					VALUES (
					'".$this->ses_id."', 
					".INTZERO($this->tm).", 
					'".addslashes($db_str)."', 
					".$this->user_id.",
					'".md5($GLOBALS["HTTP_SERVER_VARS"]["HTTP_USER_AGENT"].$GLOBALS["HTTP_SERVER_VARS"]["REMOTE_ADDR"])."'
				)");
				
			$this->db_id = DB_LASTID();
			DB_UNLOCK();	
		} 
		else {
			if ( !empty($this->user_id) && $this->user_id<2000000000 ) {
				Q("DELETE FROM fud_ses WHERE user_id=".$this->user_id." AND ses_id!='".$this->ses_id."'");
				$usr_id_fld = ' user_id='.$this->user_id.',';
			}	
			
			if( empty($GLOBALS['HTTP_COOKIE_VARS'][$GLOBALS['COOKIE_NAME']]) || $not_use_cookie ) 
				$sys_id = md5($GLOBALS["HTTP_SERVER_VARS"]["HTTP_USER_AGENT"].$GLOBALS["HTTP_SERVER_VARS"]["REMOTE_ADDR"]);
			else 
				$sys_id = 0;
			
			Q("UPDATE fud_ses SET sys_id='".$sys_id."', ".$usr_id_fld." time_sec=".$this->tm.", data='".addslashes($db_str)."' WHERE id=".$this->db_id);
		}
		
		if( empty($not_use_cookie) ) $this->cookie_set_session($this->ses_id);
		
		return $this->ses_id;
	}
	
	function restore_session($ses_id)
	{
		if( empty($this->sys_id) ) 
			$result = Q("SELECT * FROM fud_ses WHERE ses_id='".$ses_id."'");
		else
			$result = Q("SELECT * FROM fud_ses WHERE ses_id='".$ses_id."' AND sys_id='".$this->sys_id."'");	
			
		if ( !IS_RESULT($result) ) return;
		$obj = DB_SINGLEOBJ($result);
		
		$this->ses_id = $obj->ses_id;
		$this->time = $obj->time_sec;
		$this->db_id = $obj->id;
		$this->user_id = $obj->user_id;
		$this->action = $obj->action;

		$n = substr($obj->data, 0, 8)+0;		
		$obj->data = substr($obj->data, 8);
				
		for ( $i=0; $i<$n; $i++ ) {
			$key = trim(substr($obj->data, 0, 10));
			$obj->data = substr($obj->data, 10);
			$val_ln = substr($obj->data, 0, 8)+0;
			$obj->data = substr($obj->data, 8);
			$val = substr($obj->data, 0, $val_ln);
			$obj->data = substr($obj->data, $val_ln);
			
			$this->data[$key] = $val;
		}
		
		return $this->ses_id;
	}
	
	function delete_session()
	{
		if ( empty($this->db_id) ) return;	
		DB_LOCK('fud_ses+');
		Q("DELETE FROM fud_ses WHERE id=".$this->db_id);
		Q("DELETE FROM fud_ses WHERE ses_id='".$this->ses_id."'");
		unset($this->user_id);
		unset($this->ses_id);
		unset($this->db_id);
		unset($this->data);
		unset($this->action);
		clear_cookie();
		DB_UNLOCK();
		return 1;
	}
	
	function getsid()
	{
		return $this->ses_id;
	}
	
	function SID()
	{
		$GLOBALS["FRM_SID"] = "S=".$this->ses_id;
		return $GLOBALS["FRM_SID"];
	}
	
	function cookie_set_session($ses_id)
	{
		setcookie($GLOBALS['COOKIE_NAME'], $ses_id, time()+$GLOBALS['COOKIE_TIMEOUT'], $GLOBALS['COOKIE_PATH'], $GLOBALS['COOKIE_DOMAIN']);
	}
	
	function cookie_get_session()
	{
		if( !empty($GLOBALS['HTTP_COOKIE_VARS'][$GLOBALS['COOKIE_NAME']]) )
			return $this->restore_session($GLOBALS['HTTP_COOKIE_VARS'][$GLOBALS['COOKIE_NAME']]);
		else if( !empty($GLOBALS["HTTP_GET_VARS"]["S"]) || !empty($GLOBALS["HTTP_POST_VARS"]["S"]) ) {
			$this->sys_id = md5($GLOBALS["HTTP_SERVER_VARS"]["HTTP_USER_AGENT"].$GLOBALS["HTTP_SERVER_VARS"]["REMOTE_ADDR"]);
			return $this->restore_session((!empty($GLOBALS["HTTP_GET_VARS"]["S"])?$GLOBALS["HTTP_GET_VARS"]["S"]:$GLOBALS["HTTP_POST_VARS"]["S"]));
		}	
		else
			return;
	}
	
	function countvar()
	{
		return count($this->data);
	}
	
	function resetvar()
	{
		if ( is_array($this->data) ) reset($this->data);
	}
	
	function nextvar()
	{
		list($RET['key'], $RET['val']) = each($this->data);
		return $RET;
	}
}

function clear_cookie()
{
	setcookie('session', 0, time()-100000, $GLOBALS['COOKIE_PATH'], $GLOBALS['COOKIE_DOMAIN']);
}

function set_referer_cookie($id)
{
	setcookie('frm_referer_id', $id, time()+31536000, $GLOBALS['COOKIE_PATH'], $GLOBALS['COOKIE_DOMAIN']);
}

function clear_old_sessions()
{
	$tm_sample = time();
	Q("DELETE FROM fud_ses WHERE time_sec<".($tm_sample-$GLOBALS['COOKIE_TIMEOUT'])." OR (time_sec<".($tm_sample-$GLOBALS['SESSION_TIMEOUT'])." AND sys_id!=0)");
}
?>