<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: post.inc,v 1.14 2002/02/12 19:48:44 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/
if ( defined('_POST_INC_') ) return; else define('_POST_INC_', 1);
	include_once "GLOBALS.php";
	fud_use('replace.inc');
	fud_use('rev_fmt.inc');

function tags_to_html($fudml, $allow_img='Y')
{
		$html = htmlspecialchars($fudml);

		if( $allow_img=='Y' ){
			/* images [img] or [img=] */
			$html = preg_replace('!\[img=([^\]\)]*?)\]([^\[]*?)\[/img\]!is', '<img src="\1" border=0 alt="\2">', $html);
			$html = preg_replace('!\[img\]([^\]\)]*?)\[/img\]!is', '<img src="\1" border=0 alt="\1">', $html);
		}	
		
		/* deal with [email] tags */
		while ( preg_match('!\[email=([^\]\)]*?)\]([^\[]*?)\[/email\]!is', $html) )
			$html = preg_replace('!\[email=([^\]\)]*?)\]([^\[]*?)\[/email\]!is', '<a href="mailto:\1">\2 </a>', $html);
		
		while ( preg_match('!\[email]([^\]\)]*?)\[/email\]!is', $html) )
			$html = preg_replace('!\[email\]([^\]\)]*?)\[/email\]!is', '<a href="mailto:\1">\1 </a>', $html);

		/* raw emails */
		$html = preg_replace('/( |^|\s|\<|\>)([^ =\[\]\r\n@]+)@([A-Za-z0-9._]+?)\.([A-Za-z]{2,3})( |$|\s|\t|\r|\n|\<|\>)(?!<\/a>)/is', '\1<a href="mailto:\2@\3.\4">\2@\3.\4 </a>', $html);
		
		/* deal with [url=] style tags */
		while ( preg_match('!\[url=([^\]\)]*)\]([^\[\)]*)\[/url\]!is', $html) ) 
			$html = preg_replace('!\[url=([^\]\)]*)\]([^\[]*)\[/url\]!is', '<a href="\1" target=_new>\2 </a>', $html);
		
		while ( preg_match('!\[url]([^\]\)]*?)\[/url\]!is', $html) )
			$html = preg_replace('!\[url\]([^\]\)]*?)\[/url\]!is', '<a href="\1" target=_new>\1 </a>', $html);
		
		/* take raw urls out of the text */
		$html = preg_replace('/(\s|^)([A-Za-z]{3,4}):\/\/([^$\s\<\>]+)( |$|\s|\t|\r|\n|\<|\>)(?!<\/a>)/is', '\1<a href="\2://\3" target=_new>\2://\3</a>\4',  $html);
		
		$html = str_replace(' </a>', '</a>', $html);
		
		/* deal with [quote] tags */
		while ( preg_match('!\[quote\].*?\[/quote\]!is', $html) )
			$html = preg_replace('!\[quote\](.*?)\[/quote\]!is', '<table border="0" align="center" width="90%" cellpadding="3" cellspacing="1"><tr><td class="SmallText"><b>Quote:</b></td></tr><tr><td class="quote"><br>\1<br></td></tr></table>', $html);
			
		/* deal with [quote title=text] tags */
		while ( preg_match('!\[quote title=.*?\].*?\[/quote\]!is', $html) ) 
			$html = preg_replace('!\[quote title=(.*?)\](.*?)\[/quote\]!is', '<table border="0" align="center" width="90%" cellpadding="3" cellspacing="1"><tr><td class="SmallText"><b>\1</b></td></tr><tr><td class="quote"><br>\2<br></td></tr></table>', $html);
				
		/* deal with [code] tags */
		while ( preg_match('!\[code](.*?)\[/code\]!is', $html) )
			$html = preg_replace('!\[code\](.*?)\[/code\]!is', '<pre>\1</pre>', $html);
		
		/* deal with [size] tags */
		while ( preg_match('!\[size=([^\[\]]+?)\](.*?)\[/size\]!is', $html) )
			$html = preg_replace('!\[size=([^\[\]]+?)\](.*?)\[/size\]!is', '<font size="\1">\2</font>', $html);
		
		/* [color] tag */
		while ( preg_match('!\[color=([^\[\]]+?)\](.*?)\[/color\]!is', $html) )
			$html = preg_replace('!\[color=([^\[\]]+?)\](.*?)\[/color\]!is', '<font color="\1">\2</font>', $html);
		
		/* [font] tag */
		while ( preg_match('!\[font=([^\[\]]+?)\](.*?)\[/font\]!is', $html) )
			$html = preg_replace('!\[font=([^\[\]]+?)\](.*?)\[/font\]!is', '<font face="\1">\2</font>', $html);
		
		/* basic formating tags */
		while ( preg_match('!\[b\](.*?)\[/b\]!is', $html) ) 
			$html = preg_replace('!\[b\](.*?)\[/b\]!is', '<b>\1</b>', $html);
		while ( preg_match('!\[i\](.*?)\[/i\]!is', $html) ) 	
			$html = preg_replace('!\[i\](.*?)\[/i\]!is', '<i>\1</i>', $html);
		while ( preg_match('!\[u\](.*?)\[/u\]!is', $html) ) 
			$html = preg_replace('!\[u\](.*?)\[/u\]!is', '<u>\1</u>', $html);
		while ( preg_match('!\[s\](.*?)\[/s\]!is', $html) ) 
			$html = preg_replace('!\[s\](.*?)\[/s\]!is', '<s>\1</s>', $html);
		while ( preg_match('!\[center\](.*?)\[/center\]!is', $html) ) 
			$html = preg_replace('!\[center\](.*?)\[/center\]!is', '<center>\1</center>', $html);
		
		/* lists */
		while ( preg_match('!\[list\](.*?)\[/list\]!is', $html) ) 
			$html = preg_replace('!\[list\](.*?)\[/list\]!is', '<ul>\1</ul>', $html);
		$html = preg_replace('!\[list type=(1|a)\](.*?)\[/list\]!is', '<ol type="\1">\2</ol>', $html);
		$html = preg_replace('!\[list type=(square|disc|circle)\](.*?)\[/list\]!is', '<ul type="\1">\2</ul>', $html);
		$html = preg_replace('!\[\*\]([^\[]+)!is', '<li>\1', $html);
		
		$html = str_replace("\r", '', $html);
		$html = str_replace("\n", "<br>", $html);
		
		return $html;
}
function html_to_tags($html)
{
		$fudml = str_replace("\r", '', $html);
		
		while ( preg_match('!<table border="0" align="center" width="90%" cellpadding="3" cellspacing="1"><tr><td class="SmallText"><b>(.*?)</b></td></tr><tr><td class="quote"><br>(.*?)<br></td></tr></table>!is', $fudml) ) 
			$fudml = preg_replace('!<table border="0" align="center" width="90%" cellpadding="3" cellspacing="1"><tr><td class="SmallText"><b>(.*?)</b></td></tr><tr><td class="quote"><br>(.*?)<br></td></tr></table>!is', '[quote title=\1]\2[/quote]', $fudml);

		$fudml = str_replace('<br>', "\n", $fudml);

		while ( preg_match('!<b>(.*?)</b>!is', $fudml) ) 
			$fudml = preg_replace('!<b>(.*?)</b>!is', '[b]\1[/b]', $fudml);
		while ( preg_match('!<i>(.*?)</i>!is', $fudml) ) 	
			$fudml = preg_replace('!<i>(.*?)</i>!is', '[i]\1[/i]', $fudml);
		while ( preg_match('!<u>(.*?)</u>!is', $fudml) ) 
			$fudml = preg_replace('!<u>(.*?)</u>!is', '[u]\1[/u]', $fudml);
		while ( preg_match('!<s>(.*?)</s>!is', $fudml) ) 
			$fudml = preg_replace('!<s>(.*?)</s>!is', '[s]\1[/s]', $fudml);
		while ( preg_match('!<center>(.*?)</center>!is', $fudml) ) 
			$fudml = preg_replace('!<center>(.*?)</center>!is', '[center]\1[/center]', $fudml);
		while ( preg_match('!<pre>(.*?)</pre>!is', $fudml) ) 
			$fudml = preg_replace('!<pre>(.*?)</pre>!is', '[code]\1[/code]', $fudml);
		
		$fudml = preg_replace('!<img src="([^"]+)" border=0 alt="([^"]+)">!is', '[img=\1]\2[/img]', $fudml);
		$fudml = preg_replace('!<a href="([^"]+)" target=_new>([^<]+)</a>!is', '[url=\1]\2[/url]', $fudml);
		$fudml = preg_replace('!<a href="mailto:([^"]+)">([^<]+)</a>!is', '[email=\1]\2[/email]', $fudml);
		while ( preg_match('!<font color="([^"]+)">(.*?)</font>!is', $fudml) ) 
			$fudml = preg_replace('!<font color="([^"]+)">(.*?)</font>!is', '[color=\1]\2[/color]', $fudml);
		while ( preg_match('!<font face="([^"]+)">(.*?)</font>!is', $fudml) ) 	
			$fudml = preg_replace('!<font face="([^"]+)">(.*?)</font>!is', '[font=\1]\2[/font]', $fudml);
		while ( preg_match('!<font size="([^"]+)">(.*?)</font>!is', $fudml) ) 
			$fudml = preg_replace('!<font size="([^"]+)">(.*?)</font>!is', '[size=\1]\2[/size]', $fudml);
		
		
		while ( preg_match('!<ul>(.*?)</ul>!is', $fudml) ) 
			$fudml = preg_replace('!<ul>(.*?)</ul>!is', '[list]\1[/list]', $fudml);
		$fudml = preg_replace('!<ol type="([^"]+)">(.*?)</ol>!is', '[list type=\1]\2[/list]', $fudml);
		$fudml = preg_replace('!<ul type="([^"]+)">(.*?)</ul>!is', '[list type=\1]\2[/list]', $fudml);
		$fudml = str_replace('<li>', '[*]', $fudml);
		
		/* unhtmlspecialchars */
		reverse_FMT($fudml);
		
		return $fudml;
}

function filter_ext($file_name)
{
	$regexp_file = $GLOBALS['FORUM_SETTINGS_PATH'].'file_filter_regexp';
	
	if( !file_exists($regexp_file) || !filesize($regexp_file) || empty($file_name) ) return 0;
	
	$fp = fopen($regexp_file, 'r');
		$regexp = fread($fp, filesize($regexp_file));
	fclose($fp);
	
	if( preg_match('/'.$regexp.'/i', $file_name) ) return 0;
	
	return 1;
}

function list_ext()
{
	$ext='';
	$r = Q("SELECT * FROM fud_ext_block");
	while ( $obj = DB_ROWOBJ($r) ) {
		$ext .= $obj->ext.' ';	
	}
	QF($r);
	
	return ( empty($ext) ) ? '' : substr($ext, 0, -1);
}

function safe_tmp_copy($source, $del_source=0)
{
	$at_check = 0;
	while ( $at_check++ < 100 ) {
		unset($fp);
		$name = get_random_value(128);
		$tmp_file = $GLOBALS['TMP'].$name;
		$fp = @fopen($tmp_file, 'a');
		if ( $fp ) {
			if ( filesize($tmp_file) ) {
				fclose($fp);
				sleep(1);
				continue;
			}
			break;
		}
	}
	if ( !$fp ) return;
	
	$source_fp = fopen($source, 'r');
	while ( $str=fread($source_fp, 4096) ) {
		fwrite($fp, $str);
	}
	fclose($source_fp);
	fclose($fp);

	if ( $del_source ) unlink($source);

	return $name;
}

function write_msg_body($id, $data)
{
	$fp = fopen($GLOBALS["MSG_STORE_DIR"].'th_'.$id, "a");
	flock($fp, LOCK_EX);
	
	$off = ftell($fp);
	/* A hack for windows, to deal with windows' fopen symantics */
	if( !$off ) $off = filesize($GLOBALS["MSG_STORE_DIR"].'th_'.$id);
	
	fwrite($fp, $data);
	$len = (ftell($fp)-$off);
	
	fflush($fp);
	flock($fp, LOCK_UN);
	fclose($fp);

	return array($off,$len);
}

function reverse_nl2br(&$data)
{
	$data = preg_replace('!<br\s*/?\s*>!i', '', $data);
}
?>