<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: postcheck.inc,v 1.8 2002/02/11 19:36:23 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/
 if ( defined('_L_POSTCHECK_INC_') ) return; else define('_L_POSTCHECK_INC_', 1);

	include_once "GLOBALS.php";
	fud_use('style.inc');
	fud_use('fileio.inc');
	fud_use('db.inc');

$GLOBALS['__error__'] = 0;

function set_err($err, $msg)
{
	$GLOBALS['__err_msg__'][$err] = $msg;
	$GLOBALS['__error__'] = 1;
}

function is_post_error()
{
	return $GLOBALS['__error__'];
}

function get_err($err, $br=0)
{
	if( isset($err) && isset($GLOBALS['__err_msg__'][$err]) ) 
		return ($br?'':'<br>').'<font class="ErrorText">'.$GLOBALS['__err_msg__'][$err].'</font>'.(!$br?'':'<br>');
}
		
function post_check_images()
{
	global $msg_body;
	
	if ( $GLOBALS['MAX_IMAGE_COUNT'] && $GLOBALS['MAX_IMAGE_COUNT'] < count_images($msg_body) ) {
		return -1;
	}
		
	return 0;
}

function check_post_form()
{
	global $msg_subject;
	
	if ( !strlen($msg_subject) ) {
		set_err('msg_subject', 'Subject required');
	}
	
	if ( post_check_images() ) {
		set_err('msg_body', 'Maximum '.$GLOBALS['MAX_IMAGE_COUNT'].' images are allowed per post, please decrease the number of images');
	}
	
	if ( isset($GLOBALS['ses']->at_name) && filter_ext($GLOBALS['ses']->at_name) ) {
		set_err('msg_file', "This file type isn't allowed");
	}
	
	return $GLOBALS['__error__'];
} 

function check_ppost_form()
{
	global $msg_subject;
	
	if ( !strlen($msg_subject) ) {
		set_err('msg_subject', 'Subject required');
	}
	
	if ( post_check_images() ) {
		set_err('msg_body', 'Maximum '.$GLOBALS['MAX_IMAGE_COUNT'].' images are allowed per post, please decrease the number of images');
	}
	
	if ( isset($GLOBALS['ses']->at_name) && filter_ext($GLOBALS['ses']->at_name) ) {
		set_err('msg_file', "This file type isn't allowed");
	}
	
	$GLOBALS['msg_to_list'] = trim($GLOBALS['msg_to_list']);
	$list = explode(";", $GLOBALS['msg_to_list']);
	while ( list(, $v) = each($list) ) {
		$v = trim($v);
		if( strlen($v) ) {
			$r = Q("SELECT fud_users.id,fud_user_ignore.ignore_id FROM fud_users LEFT JOIN fud_user_ignore ON fud_user_ignore.user_id=fud_users.id AND fud_user_ignore.ignore_id=".$GLOBALS["usr"]->id." WHERE fud_users.login='".addslashes($v)."'");	
			if( !IS_RESULT($r) ) {
				set_err('msg_to_list', 'There is no user named "'.htmlspecialchars($v).'" this forum');
				break;
			}
			else {
				$obj = DB_SINGLEOBJ($r);
				if( !empty($obj->ignore_id) ) {
					set_err('msg_to_list', 'You cannot send a private message to "'.htmlspecialchars($v).'", because this person is ignoring you.');
					break;
				}
				else 
					$GLOBALS['recv_user_id'][] = $obj->id;	
			}		
		}
	}
	
	if( empty($GLOBALS['msg_to_list']) ) set_err('msg_to_list', 'Cannot send a message, missing recipient');

	return $GLOBALS['__error__'];
} 

function check_femail_form()
{
	if( empty($GLOBALS["HTTP_POST_VARS"]["femail"]) || validate_email($GLOBALS["HTTP_POST_VARS"]["femail"]) ) {
		set_err('femail', 'Please enter a valid email address of your friend.');
	}
	
	if( empty($GLOBALS["HTTP_POST_VARS"]["subj"]) ) {
		set_err('subj', 'You cannot send an email without a subject.');
	}
	
	if( empty($GLOBALS["HTTP_POST_VARS"]["body"]) ) {
		set_err('body', 'You cannot send an email without the message body.');
	}

	return $GLOBALS['__error__'];
}


function count_images($text)
{
	$text = strtolower($text);
	$a = substr_count($text, '[img]');
	$b = substr_count($text, '[/img]');
	
	return ( ($a>$b)?$b:$a );
}
?>