<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: thread.inc,v 1.15 2002/02/07 01:51:52 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/
 if ( defined('_THREAD_INC_') ) return; else define('_THREAD_INC_', 1);

	include_once "GLOBALS.php";
	fud_use('db.inc');
	fud_use('objutil.inc');
	
class fud_thread
{
	var $id=NULL;
	var $forum_id=NULL;
	var $root_msg_id=NULL;
	var $last_post_date=NULL;
	var $thread_starter=NULL;
	var $replies=NULL;
	var $views=NULL;
	var $rating=NULL;
	var $last_post_id=NULL;
	var $locked=NULL;
	var $hidden=NULL;
	var $is_sticky=NULL;
	var $ordertype=NULL;
	var $orderexpiry=NULL;
	var $replyallowed=NULL;
	
	var $subject=NULL;
	var $db_thread=NULL;
	
	function add($root, $forum_id, $thread_starter, $locked=NULL, $is_sticky=NULL, $ordertype=NULL, $orderexpiry=NULL, $replyallowed='Y') 
	{
		Q("INSERT INTO 
			fud_thread(
				forum_id, 
				root_msg_id, 
				last_post_date, 
				thread_starter, 
				replies, 
				views, 
				rating, 
				last_post_id,
				locked, 
				is_sticky,
				ordertype,
				orderexpiry,
				replyallowed
			)
			VALUES
			(
				".$forum_id.",
				".$root.",
				".time().",
				".$thread_starter.
				",
				0,
				0,
				0,
				".$root.",
				'".YN($locked)."',
				'".YN($is_sticky)."',
				".IFNULL($ordertype, "'NONE'").",
				".INTZERO($orderexpiry).",
				'".YN($replyallowed)."'
			)");
		$this->id = DB_LASTID();
		return $this->id;
	}
	
	function sync()
	{
		list($old_sticky,$forum_id) = DB_SINGLEARR(Q("SELECT is_sticky,forum_id FROM fud_thread WHERE id=".$this->id));
	
		Q("UPDATE fud_thread SET 
			is_sticky='".YN($this->is_sticky)."',
			ordertype=".IFNULL($this->ordertype, "'NONE'").",
			orderexpiry=".INTNULL($this->orderexpiry).",
			replyallowed='".YN($this->replyallowed)."'
		WHERE id=".$this->id);
		
		if( $old_sticky != YN($this->is_sticky) ) rebuild_forum_view($forum_id);
	}
	
	function get_by_id($id)
	{
		$result = Q("SELECT 
				fud_thread.*,
				fud_msg.subject,
				fud_forum.hidden,
				fud_cat.hidden AS cat_hidden 
			FROM 
				fud_thread 
				LEFT JOIN fud_msg 
					ON fud_thread.root_msg_id=fud_msg.id 
				LEFT JOIN fud_forum 
					ON fud_thread.forum_id=fud_forum.id 
				LEFT JOIN fud_cat 
					ON fud_forum.cat_id=fud_cat.id 
			WHERE 
				fud_thread.id=".$id);
		if ( !IS_RESULT($result) ) error_dialog('Invalid thread id','You\'ve followed an invalid link, the thread you are trying to view does not exist.','');
		
		$obj = DB_SINGLEOBJ($result);
		copy_object_from($obj, $this);
		$this->hidden = ( $obj->hidden!='Y' && $obj->cat_hidden!='Y' ) ? 'N' : 'Y';
	}

	function delete()
	{
		$msg = new fud_msg;
		$msg->get($this->root_msg_id);
		$msg->delete();
		
		rebuild_forum_view($this->forum_id);
	}
	
	function lock()
	{
		Q("UPDATE fud_thread SET locked='Y' WHERE id=".$this->id);
	}
	
	function unlock()
	{
		Q("UPDATE fud_thread SET locked='N' WHERE id=".$this->id);
	}
	
	function move($to_forum)
	{
		if ( defined('DB_LOCKED') && constant('DB_LOCKED') ) {
			DB_LOCK('fud_thread_view+, fud_thread+, fud_forum+, fud_msg+');
			$local_lock = 1;
		}
		$msg_count = Q_SINGLEVAL("SELECT count(*) FROM fud_thread LEFT JOIN fud_msg ON fud_msg.thread_id=fud_thread.id WHERE fud_msg.approved='Y' AND fud_thread.id=".$this->id);
		
		Q("UPDATE fud_thread SET forum_id=".$to_forum." WHERE id=".$this->id);
		Q("UPDATE fud_forum SET post_count=post_count-".$msg_count." WHERE id=".$this->forum_id);
		Q("UPDATE fud_forum SET thread_count=thread_count+1,post_count=post_count+".$msg_count." WHERE id=".$to_forum);
		Q("DELETE FROM fud_thread WHERE forum_id=".$to_forum." AND root_msg_id=".$this->root_msg_id." AND moved_to=".$this->forum_id);
		if( $aff_rows=DB_AFFECTED() ) Q("UPDATE fud_forum SET thread_count=thread_count-".$aff_rows." WHERE id=".$to_forum);
		Q("UPDATE fud_thread SET moved_to=".$to_forum." WHERE id!=".$this->id." AND root_msg_id=".$this->root_msg_id);
		
		Q("INSERT INTO fud_thread(
			forum_id,
			root_msg_id,
			last_post_date,
			thread_starter,
			last_post_id,
			moved_to
		)
		VALUES(
			".$this->forum_id.",
			".$this->root_msg_id.",
			".$this->last_post_date.",
			".$this->thread_starter.",
			".$this->last_post_id.",
			".$to_forum."
		)");
		
		rebuild_forum_view($this->forum_id);
		rebuild_forum_view($to_forum);
		
		if ( !empty($local_lock) ) DB_UNLOCK();
	}
	
	function inc_post_count($val)
	{
		Q("UPDATE fud_thread SET replies=replies+".$val." WHERE id=".$this->id);
	}
	
	function inc_view_count()
	{
		Q("UPDATE fud_thread SET views=views+1 WHERE id=".$this->id);
	}
	
	function dec_view_count($val)
	{
		Q("UPDATE fud_thread SET views=views-1 WHERE id=".$this->id);
	}
	
	function get_notify_list($user_id)
	{
		$ctm = time();
		$tm = $ctm-604800;
	
		$r = Q("SELECT 
				fud_users.email,
				fud_users.icq,
				fud_read.last_view,
				fud_read.id,
				fud_users.notify_method 
			FROM 
				fud_thread_notify
				INNER JOIN fud_users 
					ON fud_thread_notify.user_id=fud_users.id 
				LEFT JOIN fud_read 
					ON fud_read.user_id=fud_thread_notify.user_id 
					AND fud_read.thread_id=fud_thread_notify.thread_id 
			WHERE 
				( fud_read.msg_id=".$this->last_post_id." OR fud_read.last_view < ".$tm." )
				AND fud_thread_notify.thread_id=".$this->id." 
				AND fud_thread_notify.user_id!=".INTZERO($user_id));

		$to=NULL;
		while ( $obj = DB_ROWOBJ($r) ) {
			$to[$obj->notify_method][] = ( $obj->notify_method == 'EMAIL' ) ? $obj->email : $obj->icq.'@pager.icq.com';
				
			if( $obj->last_view < $tm ) Q("UPDATE fud_read SET last_view=".$ctm." WHERE id=".$obj->id);
		}
		QF($r);
		
		return $to;
	}
	
	function adm_set_rating($value)
	{
		Q("UPDATE fud_thread SET rating=".INTNULL($value)." WHERE id=".$this->id);
	}

	function has_thread_vote($user_id, $thread_id='')
	{
		if ( !$thread_id ) $thread_id = $this->id;
		
		if( ($rating=Q_SINGLEVAL("SELECT rating FROM fud_thread_rate_track WHERE thread_id=".$thread_id." AND user_id=".$user_id)) ) {
			return $rating;	
		}
		return -1;
	}
	
	function update_vote_count()
	{
		$rating = Q_SINGLEVAL("SELECT ROUND(AVG(rating)) FROM fud_thread_rate_track WHERE thread_id=".$this->id);
		Q("UPDATE fud_thread SET rating=".$rating." WHERE id=".$this->id);
	}
	
	function vote_count($thread_id='')
	{
		if ( !$thread_id ) $thread_id = $this->id;
		
		return Q_SINGLEVAL("SELECT COUNT(*) FROM fud_thread_rate_track WHERE thread_id=".$thread_id);
	}
	
	function register_thread_vote($user_id, $rating, $thread_id='')
	{
		if ( !$thread_id ) $thread_id = $this->id;
		
		if( !DB_LOCKED() ) {
			DB_LOCK('fud_thread_rate_track+, fud_thread+');
			$local_lock = 1;
		}
		
		if( $this->has_thread_vote($user_id, $thread_id) != -1 ) {
			if ( $local_lock ) DB_UNLOCK();
			return;
		}	
		
		Q("INSERT INTO fud_thread_rate_track (
			thread_id,
			user_id,
			stamp,
			rating
			)
		VALUES(
			".$thread_id.",
			".$user_id.",
			".time().",
			".$rating."
		)");
		
		$rating = Q_SINGLEVAL("SELECT ROUND(AVG(rating)) FROM fud_thread_rate_track WHERE thread_id=".$thread_id);
		
		Q("UPDATE fud_thread SET rating=".$rating." WHERE id=".$thread_id);
		
		if ( $local_lock ) DB_UNLOCK();
	}
}

function rebuild_forum_view($forum_id, $page=0)
{
	if( !DB_LOCKED() ) {
	        DB_LOCK('fud_thread_view+, fud_thread+, fud_msg+');
		$local_lock=1;
	}
	
	$tm = time();

	if( $page ) {
		$r=Q("SELECT 
			fud_thread_view.forum_id,
			fud_thread_view.thread_id AS id, 
			IF(is_sticky='Y' AND (fud_msg.post_stamp+fud_thread.orderexpiry>1012859045 OR fud_thread.orderexpiry=0), 4200000000, fud_thread.last_post_id) AS sort_order_fld 
		FROM 
			fud_thread_view 
			INNER JOIN fud_thread 
				ON fud_thread_view.thread_id=fud_thread.id 
			INNER JOIN fud_msg 
				ON fud_thread.root_msg_id=fud_msg.id 
			WHERE 
				fud_thread_view.forum_id=".$forum_id."
				AND page<".($page+1)."
		ORDER BY 
			sort_order_fld DESC, 
			fud_thread.last_post_date DESC");
		Q("DELETE FROM fud_thread_view WHERE forum_id=".$forum_id." AND page<".($page+1));
	}
	else {
		$r = Q("SELECT 
				fud_thread.id, 
				fud_thread.forum_id,
				IF(is_sticky='Y' AND (fud_msg.post_stamp+fud_thread.orderexpiry>".$tm." OR fud_thread.orderexpiry=0), 4200000000, fud_thread.last_post_id) AS sort_order_fld
			FROM 
				fud_thread
				INNER JOIN fud_msg
					ON fud_thread.root_msg_id=fud_msg.id
			WHERE 
				forum_id=".$forum_id."
			ORDER BY 
				sort_order_fld DESC, 
				fud_thread.last_post_date DESC");
				
		Q("DELETE FROM fud_thread_view WHERE forum_id=".$forum_id);	
	}
	
	$i=0;
	$cnt = 0;
	$page = 1;
	$vlist = '';
		
	while ( $obj = DB_ROWOBJ($r) ) {
		if ( $i && !($i%$GLOBALS['THREADS_PER_PAGE']) ) {
			$vlist = substr($vlist, 0, -1);
			Q("INSERT INTO fud_thread_view (page, forum_id, thread_id, pos) VALUES $vlist");
			$vlist = '';
			$page++;
			$cnt = 0;
		}	

		$vlist .= '('.$page.', '.$obj->forum_id.', '.$obj->id.', '.++$cnt.'),';
		$i++;
	}
	
	if ( strlen($vlist) ) {
		$vlist = substr($vlist, 0, -1);
		Q("INSERT INTO fud_thread_view (page, forum_id, thread_id, pos) VALUES $vlist");
	}
	QF($r);	
	
	if( $local_lock ) DB_UNLOCK();
}
?>