<?php
/***************************************************************************
*   copyright            : (C) 2001,2002 Advanced Internet Designs Inc.
*   email                : forum@prohost.org
*
*   $Id: users.inc,v 1.13 2002/02/12 19:55:00 hackie Exp $
****************************************************************************
          
****************************************************************************
*
*	FUDforum version 1.0, Copyright (C) 2001,2002 Advanced Internet Designs Inc.
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	Copy of the GNU General Public License can be found at 
*	http://www.prohost.org/GPL.txt
*
***************************************************************************/
 if ( defined('_USERS_INC_') ) return; else define('_USERS_INC_', 1);

	include_once "GLOBALS.php";
	fud_use("db.inc");
	fud_use("time.inc");
	fud_use('cookies.inc');

class fud_user
{
	var $id=NULL;
	var $login=NULL;
	
	var $passwd=NULL;
	var $plaintext_passwd=NULL;
	
	var $name=NULL;
	
	var $email=NULL;
	var $location=NULL;
	var $occupation=NULL;
	var $interests=NULL;
	var $display_email=NULL;
	var $notify=NULL;
	var $notify_method=NULL;
	var $private_messages=NULL;
	var $gender=NULL;
	
	var $icq=NULL;
	var $aim=NULL;
	var $yahoo=NULL;
	var $msnm=NULL;
	
	var $avatar=NULL;
	var $avatar_loc=NULL;
	var $avatar_approved=NULL;
	
	var $append_sig=NULL;
	var $show_sigs=NULL;
	var $show_tool_tips=NULL;
	var $posts_ppg=NULL;
	var $time_zone=NULL;
	var $invisible_mode=NULL;
	var $ignore_admin=NULL;
	var $bday=NULL;
	var $blocked=NULL;
	
	var $home_page=NULL;
	var $sig=NULL;
	var $bio=NULL;
	
	var $started_topics=NULL;
	var $posted_msg_count=NULL;
	var $last_visit=NULL;
	var $last_event=NULL;
	var $email_conf=NULL;
	var $conf_key=NULL;
	var $coppa=NULL;
	var $user_image=NULL;
	var $join_date=NULL;
	var $style=NULL;
	var $last_read=NULL;
	var $default_view=NULL;
	var $mod_list=NULL;
	var $mod_cur=NULL;
	var $is_mod=NULL;
	var $level_id=NULL;
	
	function get_user_by_id($id) 
	{
		QOBJ("SELECT * FROM fud_users WHERE id=".$id, $this);
		if( empty($this->id) ) return;

		$GLOBALS['layout'] = $this->style;
		
		if ( $GLOBALS['USER_REG'] ) {
			$ext = read_ext_settings($this->id);
			$this->home_page 	= $ext['home_page'];
			$this->bio		= $ext['bio'];
		}
		
		return $this;
	}
	
	function set_post_count($val)
	{
		if( !DB_LOCKED() ) {
			DB_LOCK('fud_users+, fud_level+');
			$local_lock=1;
		}
	
		$pcount = Q_SINGLEVAL("SELECT posted_msg_count FROM fud_users WHERE id=".$this->id);
		$pcount += $val;
	
		if( $pcount<0 ) $pcount=0;
	
		$level_id = Q_SINGLEVAL("SELECT id FROM fud_level WHERE post_count<=".$pcount." ORDER BY post_count DESC LIMIT 1");
		
		if( !$level_id ) $level_id=0;
		
		Q("UPDATE fud_users SET posted_msg_count=posted_msg_count+".$val.",level_id=".$level_id." WHERE id=".$this->id);
		
		if( $local_lock ) DB_UNLOCK();
	}
	
	function register_thread_view($thread_id, $msg_id='')
	{
		$r = Q("SELECT * FROM fud_read WHERE thread_id=".$thread_id." AND user_id=".$this->id);
		$obj = DB_SINGLEOBJ($r); 

		if ( $obj ) {
			$msg_id = ( $msg_id > $obj->msg_id ) ? $msg_id : $obj->msg_id;
			Q("UPDATE fud_read SET last_view=".time().", msg_id=".INTZERO($msg_id)." WHERE id=".$obj->id);
		}
		else {
			Q("INSERT INTO fud_read(thread_id, user_id, msg_id, last_view) VALUES(".$thread_id.", ".$this->id.", ".INTZERO($msg_id).", ".time().")");
		}
	}
	
	function register_forum_view($frm_id)
	{
		$id = Q_SINGLEVAL("SELECT id FROM fud_forum_read WHERE forum_id=".$frm_id." AND user_id=".$this->id);

		if ( $id ) 
			Q("UPDATE fud_forum_read SET last_view=".time()." WHERE id=".$id);
		else 
			Q("INSERT INTO fud_forum_read(forum_id, user_id, last_view) VALUES(".$frm_id.", ".$this->id.",".time().")");
	}
	
	function mark_all_read()
	{
		Q("UPDATE fud_users SET last_read=".time()." WHERE id=".$this->id);
	}
}

if ( $GLOBALS['USER_REG'] ) {
	fud_use('users_reg.inc');
}

if ( $GLOBALS['ADMIN_FORM'] ) {
	fud_use('users_reg.inc');
	fud_use('users_adm.inc');
}

function init_user()
{
	global $_RSID;

	$s = new fud_session;
	if ( $GLOBALS['ADMIN_FORM'] ) 
		$u = new fud_user_adm;
	else if ( $GLOBALS['USER_REG'] )
		$u = new fud_user_reg;
	else
		$u = new fud_user;
	
	$s->cookie_get_session();
	if ( $s->getvar('user_id') ) {
		if ( !$u->get_user_by_id($s->getvar('user_id')) ) {
			unset($u);
			$s->delete_session();
		}
	}
	else $u = NULL;
				
	if ( empty($u) ) $s->save_session();

	$rv[0] = $s;

	if( !empty($u) ) {
		set_tz($u->time_zone);
		$GLOBALS['D_THREAD_VIEW'] = $u->default_view;
		Q("UPDATE fud_users SET last_visit=".time()." WHERE id=".$u->id);
		$rv[1] = $u;
		$_RSID = 'rid='.$u->id.'&';
	}
	else {
		set_tz($GLOBALS["SERVER_TZ"]);
		$GLOBALS['D_THREAD_VIEW'] = $GLOBALS['DEFAULT_THREAD_VIEW'];
		$rv[1] = NULL;
		if( !empty($GLOBALS["rid"]) && empty($GLOBALS["HTTP_COOKIE_VARS"]["frm_referer_id"]) ) set_referer_cookie($GLOBALS["rid"]);
	}

	$GLOBALS["S"] = $s->ses_id;
	$_RSID .= 'S='.$GLOBALS["S"];
	
	return $rv;
}

function read_ext_settings($id)
{
	if ( empty($id) ) return;

	if ( !file_exists($GLOBALS['USER_SETTINGS_PATH'].$id.'.fud') || !($fp = fopen($GLOBALS['USER_SETTINGS_PATH'].$id.'.fud', 'r')) ) {
		return;
	}
	
	$ln = fread($fp, 8)+0;
	$RET['home_page'] = fread($fp, $ln);
	
	$ln = fread($fp, 8)+0;
	$RET['bio'] = fread($fp, $ln);
	
	fclose($fp);

	return $RET;	
}
?>